<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:include href="../xsl_util.xsl"/>
<xsl:output method="text" encoding="utf-8" indent="yes"/><xsl:param name = "save_path" />
<xsl:param name = "xml_path" />
<!-- TODO : xalan 을 이용하는 배치파일을 만든다. 컴포넌트.xml + excute_xalan = 컴포넌트.bat = 헤더파일 + 소스파일 + cmake 파일 + 등등..... --><!-- xalan $xalan_out "c:\dev/ncgen.bat" $xalan_param save_path "'c:\dev'" "c:\dev\ai data.xml" "./xsl/excute_xalan.xsl" -->
<xsl:template match="/">
<xsl:variable name="component_name">
  <xsl:call-template name="replace">
    <xsl:with-param name="text" select="nerv_icde/component/name" />
    <xsl:with-param name="replace" select="' '" />
    <xsl:with-param name="by" select="'_'" />
  </xsl:call-template>
</xsl:variable>
<xsl:text/>#!/bin/bash
echo $0 $@

source /usr/local/share/Nerv/Nerv36/script_make/xalan_option

<xsl:for-each select="nerv_icde/datadomain/row">
mkdir -p "<xsl:value-of select="$save_path"/>/src/Nerv36/Data<xsl:value-of select="path"/>"<xsl:text/>
  <xsl:variable name="path" select="path"/>
  <xsl:for-each select="data/row">
xalan $xalan_out "<xsl:value-of select="$save_path"/>/src/Nerv36/Data<xsl:value-of select="$path"/>/<xsl:value-of select="name"/>.cs" $xalan_param export_data_domain_path "'<xsl:value-of select="$path"/>'" $xalan_param export_data_name "'<xsl:value-of select="name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CS/src/Nerv36/Data/data_domain_data_cs.xsl"<xsl:text/>
  </xsl:for-each>
</xsl:for-each>

<xsl:for-each select="nerv_icde/methoddomain/row">
mkdir -p "<xsl:value-of select="$save_path"/>/src/Nerv36/Method<xsl:value-of select="path"/>"
  <xsl:variable name="path" select="path"/>
  <xsl:for-each select="method/row">
xalan $xalan_out "<xsl:value-of select="$save_path"/>/src/Nerv36/Method<xsl:value-of select="$path"/>/<xsl:value-of select="name"/>.cs" $xalan_param export_method_domain_path "'<xsl:value-of select="$path"/>'" $xalan_param export_method_name "'<xsl:value-of select="name"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CS/src/Nerv36/Method/method_domain_method_cs.xsl"<xsl:text/>
  </xsl:for-each>
xalan $xalan_out "<xsl:value-of select="$save_path"/>/src/Nerv36/Method<xsl:value-of select="$path"/>/<xsl:value-of select="name"/>.cs" $xalan_param export_method_domain_path "'<xsl:value-of select="$path"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CS/src/Nerv36/Method/method_domain_cs.xsl"<xsl:text/>
</xsl:for-each>

<xsl:for-each select="nerv_icde/component/proxy_list/row">
mkdir -p "<xsl:value-of select="$save_path"/>/src/Nerv_Proxy/<xsl:value-of select="class_name"/>"
xalan $xalan_out "<xsl:value-of select="$save_path"/>/src/Nerv_Proxy/<xsl:value-of select="class_name"/>/<xsl:value-of select="class_name"/>.cs" $xalan_param export_proxy_class_id "'<xsl:value-of select="id"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CS/src/Nerv_Proxy/proxy_class_cs.xsl"
</xsl:for-each>
<xsl:for-each select="nerv_icde/component/stub_list/row">
mkdir -p "<xsl:value-of select="$save_path"/>/src/Nerv_Stub/<xsl:value-of select="class_name"/>"
xalan $xalan_out "<xsl:value-of select="$save_path"/>/src/Nerv_Stub/<xsl:value-of select="class_name"/>/<xsl:value-of select="class_name"/>.cs" $xalan_param export_stub_class_id "'<xsl:value-of select="id"/>'" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CS/src/Nerv_Stub/stub_class_cs.xsl"
</xsl:for-each>

xalan $xalan_out "<xsl:value-of select="$save_path"/>/src/Nerv_component_<xsl:value-of select="$component_name"/>.cs" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CS/src/cs_nerv36_component.xsl"

xalan $xalan_out "<xsl:value-of select="$save_path"/>/CMakeLists.txt" $xalan_in "<xsl:value-of select="$xml_path"/>" $xalan_xsl "/usr/local/share/Nerv/Nerv36/XSL/CS/CMakeLists.xsl"

cp -rv "/usr/local/share/Nerv/Nerv36/XSL/CS/.script" "<xsl:value-of select="$save_path"/>/."

</xsl:template>
</xsl:stylesheet>
