<?xml version="1.0" encoding="UTF-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="text" encoding="utf-8" indent="yes"/>




<xsl:template name ="template_callback" >
  <xsl:variable name="out_data_domain_namespace">
    <xsl:call-template name="get_data_domain_namespace_dot">
      <xsl:with-param name="data_domain_id" select="out_data_domain_id" />
    </xsl:call-template>
  </xsl:variable>
  <xsl:variable name="in_data_domain_namespace">
    <xsl:call-template name="get_data_domain_namespace_dot">
      <xsl:with-param name="data_domain_id" select="in_data_domain_id" />
    </xsl:call-template>
  </xsl:variable>

// proxy
public interface IProxy_method_<xsl:value-of select="name"/>
{
    Int32 on_callback( <xsl:if test="out_data!='(null)'">ref Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/> _cal_dat_,</xsl:if> <xsl:if test="in_data!='(null)'">ref Nerv36.Data<xsl:value-of select="$in_data_domain_namespace"/>.<xsl:value-of select="in_data"/> _return_data_,</xsl:if> double _elapsed, double _limit);
    void on_cancel( Int32 _err);
}
public unsafe class Proxy_method_<xsl:value-of select="name"/>
{
    static Nerv36.Proxy_callback.on_callback_ft on_callback_ = new Nerv36.Proxy_callback.on_callback_ft(on_callback);
    static Nerv36.Proxy_callback.on_cancel_ft on_cancel_ = new Nerv36.Proxy_callback.on_cancel_ft(on_cancel);
    static ConcurrentDictionary&lt;IntPtr, Proxy_method_<xsl:value-of select="name"/>&gt; dict = new ConcurrentDictionary&lt;IntPtr, Proxy_method_<xsl:value-of select="name"/>&gt;();

    public static Int32 on_callback(IntPtr _callback_, IntPtr _cal_dat_, UInt32 _cal_size, IntPtr _return_data_, ref UInt32 _return_size,  double _elapsed, double _limit)
    {<xsl:if test="out_data!='(null)'">
        Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/>* cal_data_ = (Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/>*)_cal_dat_;
        </xsl:if>
        <xsl:if test="in_data!='(null)'">
        Nerv36.Data<xsl:value-of select="$in_data_domain_namespace"/>.<xsl:value-of select="in_data"/>* return_data_ = (Nerv36.Data<xsl:value-of select="$in_data_domain_namespace"/>.<xsl:value-of select="in_data"/>*)_return_data_;
        return_data_->init_dynamic_buffer(_return_size - Nerv36.Data<xsl:value-of select="$in_data_domain_namespace"/>.<xsl:value-of select="in_data"/>._sizeof);
        </xsl:if>
        return dict[_callback_].icallback.on_callback(<xsl:if test="out_data!='(null)'"> ref *cal_data_,</xsl:if><xsl:if test="in_data!='(null)'"> ref *return_data_,</xsl:if> _elapsed, _limit);
    }
    public static void on_cancel(IntPtr _callback_, Int32 _err)
    {
        dict[_callback_].icallback.on_cancel(_err);
    }

    public IntPtr callback_;
    public IProxy_method_<xsl:value-of select="name"/> icallback;

    public Proxy_method_<xsl:value-of select="name"/>(ref Nerv36.Proxy _object_, IProxy_method_<xsl:value-of select="name"/> _icallback)
    {
        callback_ = Nerv36.Proxy_callback.alloc(<xsl:value-of select="code"/>, <xsl:if test="in_data!='(null)'">Nerv36.Data<xsl:value-of select="$in_data_domain_namespace"/>.<xsl:value-of select="in_data"/>._sizeof</xsl:if><xsl:if test="in_data='(null)'">0</xsl:if>, _object_.object_, on_callback_, on_cancel_);
        dict[callback_] = this;
        icallback = _icallback;
    }
    ~Proxy_method_<xsl:value-of select="name"/>()
    {
        // Nerv36.Proxy_callback.free(callback_);
        // API.nerv_finalize()에서 정리되지 않은 객체를 자동해제하므로
        // C#에서는 Nerv36.Proxy_callback.free(callback_); 로 정리하지 않는다.
        // C#의 소멸자는 언제 호출될지 알수 없다.

        Proxy_method_<xsl:value-of select="name"/> callback;
        dict.TryRemove(callback_, out callback);
    }
}

// stub
public interface IStub_method_<xsl:value-of select="name"/>
{
    void on_return(UInt32 _msg_num, Address _proxy_addr, Int32 _err,<xsl:if test="in_data!='(null)'"> ref Nerv36.Data<xsl:value-of select="$in_data_domain_namespace"/>.<xsl:value-of select="in_data"/> _ret_dat_,</xsl:if> Double _elapsed);
}
public unsafe class Stub_method_<xsl:value-of select="name"/>
{
    static Nerv36.Stub_callback.on_return_ft on_return_ = new Nerv36.Stub_callback.on_return_ft(on_return);

    static ConcurrentDictionary&lt;IntPtr, Stub_method_<xsl:value-of select="name"/>&gt; dict = new ConcurrentDictionary&lt;IntPtr, Stub_method_<xsl:value-of select="name"/>&gt;();

    public static void on_return(IntPtr _callback_, UInt32 _msg_num, Address _proxy_addr, Int32 _err, IntPtr _ret_dat_, UInt32 _ret_size, Double _elapsed)
    {<xsl:if test="in_data!='(null)'">
        Nerv36.Data<xsl:value-of select="$in_data_domain_namespace"/>.<xsl:value-of select="in_data"/>* ret_data_ = (Nerv36.Data<xsl:value-of select="$in_data_domain_namespace"/>.<xsl:value-of select="in_data"/>*)_ret_dat_;
        </xsl:if>
        dict[_callback_].icallback.on_return(_msg_num, _proxy_addr, _err,<xsl:if test="in_data!='(null)'"> ref *ret_data_,</xsl:if> _elapsed);
    }

    public IntPtr callback_;
    public IStub_method_<xsl:value-of select="name"/> icallback;

    public Stub_method_<xsl:value-of select="name"/>(ref Nerv36.Stub _object_, IStub_method_<xsl:value-of select="name"/> _icallback)
    {
        callback_ = Nerv36.Stub_callback.alloc(<xsl:value-of select="code"/>, _object_.object_, on_return_);
        dict[callback_] = this;
        icallback = _icallback;
    }
    ~Stub_method_<xsl:value-of select="name"/>()
    {
        // Nerv36.Stub_callback.free(callback_);
        // API.nerv_finalize()에서 정리되지 않은 객체를 자동해제하므로
        // C#에서는 Nerv36.Stub_callback.free(callback_); 로 정리하지 않는다.
        // C#의 소멸자는 언제 호출될지 알수 없다.

        Stub_method_<xsl:value-of select="name"/> callback;
        dict.TryRemove(callback_, out callback);
    }


    public Int32 delegate_callback(ref UInt32 _msg_num_, Address _proxy_addr,<xsl:if test="out_data!='(null)'"> ref Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/> _cal_dat_,</xsl:if> Double _limit)
    {
        Int32 err;
        <xsl:if test="out_data!='(null)'">
        UInt32 cal_size = (UInt32)_cal_dat_.fit_size();
        fixed ( Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/>* cal_data_ = &amp;_cal_dat_)
        {
            err = Nerv36.Stub_callback.delegate_callback( callback_, ref _msg_num_, _proxy_addr, (IntPtr)cal_data_, cal_size, _limit);
        }
        </xsl:if>
        <xsl:if test="out_data='(null)'">
        err = Nerv36.Stub_callback.delegate_callback( callback_, ref _msg_num_, _proxy_addr, IntPtr.Zero, 0, _limit);
        </xsl:if>
        return err;
    }


    public IntPtr async_callback(Address _proxy_addr, <xsl:if test="out_data!='(null)'">ref Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/> _cal_dat_,</xsl:if> Double _limit)
    {

        <xsl:if test="out_data!='(null)'">
        IntPtr promise_;
        UInt32 cal_size = (UInt32)_cal_dat_.fit_size();
        fixed ( Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/>* cal_data_ = &amp;_cal_dat_)
        {
            promise_ = Nerv36.Stub_callback.async_callback( callback_, _proxy_addr, (IntPtr)cal_data_, cal_size, _limit);
        }
        </xsl:if>
        <xsl:if test="out_data='(null)'">
        IntPtr promise_ = Nerv36.Stub_callback.async_callback( callback_, _proxy_addr, IntPtr.Zero, 0, _limit);
        </xsl:if>
        return promise_;
    }


    public Int32 await_return(IntPtr _promise_, <xsl:if test="in_data!='(null)'">ref Nerv36.Data<xsl:value-of select="$in_data_domain_namespace"/>.<xsl:value-of select="in_data"/> _return_data_,</xsl:if> ref Double _elapsed_ )
    {
        <xsl:if test="in_data!='(null)'">
        UInt32 return_size = (UInt32)Nerv36.Data<xsl:value-of select="$in_data_domain_namespace"/>.<xsl:value-of select="in_data"/>._sizeof;
        fixed ( Nerv36.Data<xsl:value-of select="$in_data_domain_namespace"/>.<xsl:value-of select="in_data"/>* return_data_ = &amp;_return_data_)
        {
            Int32 err = Nerv36.Stub_callback.await_return(callback_, _promise_, (IntPtr)return_data_, ref return_size, ref _elapsed_);
            return err;
        }
        </xsl:if>
        <xsl:if test="in_data='(null)'">
        UInt32 return_size = 0;
        Int32 err = Nerv36.Stub_callback.await_return(callback_, _promise_, IntPtr.Zero, ref return_size, ref _elapsed_);
        return err;
        </xsl:if>
    }

    public Int32 callback(Address _proxy_addr, <xsl:if test="out_data!='(null)'">ref Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/> _cal_dat_,</xsl:if>
                      <xsl:if test="in_data!='(null)'">ref Nerv36.Data<xsl:value-of select="$in_data_domain_namespace"/>.<xsl:value-of select="in_data"/> _return_data_,</xsl:if>
                      Double _limit , ref Double _elapsed_ )
    {
        <xsl:if test="out_data!='(null)'">
        IntPtr promise_;
        UInt32 cal_size = (UInt32)_cal_dat_.fit_size();
        fixed ( Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/>* cal_data_ = &amp;_cal_dat_)
        {
            promise_ = Nerv36.Stub_callback.async_callback( callback_, _proxy_addr, (IntPtr)cal_data_, cal_size, _limit);
        }
        </xsl:if>
        <xsl:if test="out_data='(null)'">
        IntPtr promise_ = Nerv36.Stub_callback.async_callback( callback_, _proxy_addr, IntPtr.Zero, 0, _limit);
        </xsl:if>
        <xsl:if test="in_data!='(null)'">
        UInt32 return_size = (UInt32)Nerv36.Data<xsl:value-of select="$in_data_domain_namespace"/>.<xsl:value-of select="in_data"/>._sizeof;
        fixed ( Nerv36.Data<xsl:value-of select="$in_data_domain_namespace"/>.<xsl:value-of select="in_data"/>* return_data_ = &amp;_return_data_)
        {
            Int32 err = Nerv36.Stub_callback.await_return(callback_, promise_, (IntPtr)return_data_, ref return_size, ref _elapsed_);
            return err;
        }
        </xsl:if>
        <xsl:if test="in_data='(null)'">
        UInt32 return_size = 0;
        Int32 err = Nerv36.Stub_callback.await_return(callback_, promise_, IntPtr.Zero, ref return_size, ref _elapsed_);
        return err;
        </xsl:if>

    }

    public void cancel(Address _proxy_addr, Int32 _err)
    {
        Nerv36.Stub_callback.cancel(callback_, _proxy_addr, _err);
    }
}


</xsl:template>




</xsl:stylesheet>
