<?xml version="1.0" encoding="UTF-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="text" encoding="utf-8" indent="yes"/>





<xsl:template name ="template_command" >
  <xsl:variable name="in_data_domain_namespace">
    <xsl:call-template name="get_data_domain_namespace_dot">
      <xsl:with-param name="data_domain_id" select="in_data_domain_id" />
    </xsl:call-template>
  </xsl:variable>
  <xsl:variable name="out_data_domain_namespace">
    <xsl:call-template name="get_data_domain_namespace_dot">
      <xsl:with-param name="data_domain_id" select="out_data_domain_id" />
    </xsl:call-template>
  </xsl:variable>
// proxy
public interface IProxy_method_<xsl:value-of select="name"/>
{
    void on_link(UInt32 _msg_num, Int32 _err, Double _elapsed);
    void on_unlink(Int32 _err);
}
public unsafe class Proxy_method_<xsl:value-of select="name"/>
{
    static Nerv36.Proxy_command.on_link_ft on_link_ = new Nerv36.Proxy_command.on_link_ft(on_link);
    static Nerv36.Proxy_command.on_unlink_ft on_unlink_ = new Nerv36.Proxy_command.on_unlink_ft(on_unlink);
    static ConcurrentDictionary&lt;IntPtr, Proxy_method_<xsl:value-of select="name"/>&gt; dict = new ConcurrentDictionary&lt;IntPtr, Proxy_method_<xsl:value-of select="name"/>&gt;();

    public static void on_unlink(IntPtr _command_, Int32 _err)
    {
        dict[_command_].icommand.on_unlink(_err);
    }

    public static void on_link(IntPtr _command_, UInt32 _msg_num, Int32 _err, Double _elapsed)
    {
        dict[_command_].icommand.on_link(_msg_num, _err, _elapsed);
    }

    public IntPtr command_;
    public IProxy_method_<xsl:value-of select="name"/> icommand;

    public Proxy_method_<xsl:value-of select="name"/>(ref Nerv36.Proxy _object_, IProxy_method_<xsl:value-of select="name"/> _icommand)
    {
        command_ = Nerv36.Proxy_command.alloc(<xsl:value-of select="code"/>, _object_.object_,on_link_,on_unlink_);
        dict[command_] = this;
        icommand = _icommand;
    }
    ~Proxy_method_<xsl:value-of select="name"/>()
    {
        // Nerv36.Proxy_command.free(command_);
        // API.nerv_finalize()에서 정리되지 않은 객체를 자동해제하므로
        // C#에서는 Nerv36.Proxy_command.free(command_); 로 정리하지 않는다.
        // C#의 소멸자는 언제 호출될지 알수 없다.

        Proxy_method_<xsl:value-of select="name"/> command_reference;
        dict.TryRemove(command_, out command_reference);
    }

    public Boolean is_linked()
    {
        Boolean b = Nerv36.Proxy_command.is_linked(command_);
        return b;
    }

    public Int32 delegate_link(ref UInt32 _msg_num_, Double _limit)
    {
        Int32 err = Nerv36.Proxy_command.delegate_link( command_, ref _msg_num_, _limit);
        return err;
    }

    public IntPtr async_link(Double _limit)
    {
        IntPtr promise_ = Nerv36.Proxy_command.async_link(command_, _limit);
        return promise_;
    }

    public Int32 await_link_return(IntPtr _promise_, ref Double _elapsed_)
    {
        Int32 err = Nerv36.Proxy_command.await_link_return(command_, _promise_, ref _elapsed_);
        return err;
    }

    public Int32 link(Double _limit, ref Double _elapsed_)
    {
        IntPtr promise_ = Nerv36.Proxy_command.async_link( command_, _limit);
        Int32 err = Nerv36.Proxy_command.await_link_return(command_, promise_, ref _elapsed_);
        return err;
    }

    public void unlink()
    {
        Nerv36.Proxy_command.unlink(command_);
    }

    public void set_sync_model(Boolean _reliability, Sync_model _sync_model, Double _interval)
    {
        Nerv36.Proxy_command.set_sync_model(command_, _reliability, _sync_model, _interval);
    }

    public IntPtr see_history(UIntPtr _history_size)
    {
        IntPtr letter_ = Nerv36.Proxy_command.see_history(command_, _history_size);
        return letter_;
    }

    public void set_history_size(UIntPtr _history_size)
    {
        Nerv36.Proxy_command.set_history_size(command_, _history_size);
    }
  <xsl:if test="in_data!='(null)'">
    public ref Nerv36.Data<xsl:value-of select="$in_data_domain_namespace"/>.<xsl:value-of select="in_data"/> get()
    {
        IntPtr cmd_data_ = Nerv36.Proxy_command.get(command_, Nerv36.Data<xsl:value-of select="$in_data_domain_namespace"/>.<xsl:value-of select="in_data"/>._sizeof);
        return ref *(Nerv36.Data<xsl:value-of select="$in_data_domain_namespace"/>.<xsl:value-of select="in_data"/>*)cmd_data_;
    }

    public void cancel()
    {
        Nerv36.Proxy_command.cancel(command_);
    }

    public Int32 post(ref Nerv36.Data<xsl:value-of select="$in_data_domain_namespace"/>.<xsl:value-of select="in_data"/> _cmd_dat_ )
    {
        // 데이터를 post함수를 통해서 전달하지는 않고, 다만 크기만 지정한다
        // post 데이터 메모리는 get 으로 획득한 공간이다.
        Int32 err = Nerv36.Proxy_command.post(command_, _cmd_dat_.fit_size() );
        return err;
    }

    public Int32 read(ref Nerv36.Data<xsl:value-of select="$in_data_domain_namespace"/>.<xsl:value-of select="in_data"/> _cmd_dat_)
    {
        UInt32 cmd_size = (UInt32)_cmd_dat_.sizeofall();
        fixed ( Nerv36.Data<xsl:value-of select="$in_data_domain_namespace"/>.<xsl:value-of select="in_data"/>* cmd_data_ = &amp;_cmd_dat_)
        {
            Int32 err = Nerv36.Proxy_command.read(command_, (IntPtr)cmd_data_, ref cmd_size);
            return err;
        }
    }
  </xsl:if>

    public Int32 write(<xsl:if test="in_data!='(null)'">ref Nerv36.Data<xsl:value-of select="$in_data_domain_namespace"/>.<xsl:value-of select="in_data"/> _cmd_dat_</xsl:if>)
    {
  <xsl:if test="in_data!='(null)'">
        fixed (Nerv36.Data<xsl:value-of select="$in_data_domain_namespace"/>.<xsl:value-of select="in_data"/>* cmd_data_ = &amp;_cmd_dat_)
        {
            Int32 err = Nerv36.Proxy_command.write(command_, (IntPtr)cmd_data_, _cmd_dat_.fit_size() );
            return err;
        }
  </xsl:if>
  <xsl:if test="in_data='(null)'">
        Int32 err = Nerv36.Proxy_command.write(command_, IntPtr.Zero, 0);
        return err;
  </xsl:if>
    }
}

// stub
public interface IStub_method_<xsl:value-of select="name"/>
{
    Int32 on_link(Address _proxy_addr, Double _elapsed, Double _limit);
    void on_unlink(Address _proxy_addr, Int32 _err);
    void on_sync(Address _proxy_addr, Sync_model _sync_model, Double _elapsed, Double _limit<xsl:if test="in_data!='(null)'">, ref Nerv36.Data<xsl:value-of select="$in_data_domain_namespace"/>.<xsl:value-of select="in_data"/> _cmd_dat_</xsl:if>);
}

public unsafe class Stub_method_<xsl:value-of select="name"/>
{
    static Nerv36.Stub_command.on_link_ft on_link_     = new Nerv36.Stub_command.on_link_ft(on_link);
    static Nerv36.Stub_command.on_unlink_ft on_unlink_ = new Nerv36.Stub_command.on_unlink_ft(on_unlink);
    static Nerv36.Stub_command.on_sync_ft on_sync_     = new Nerv36.Stub_command.on_sync_ft(on_sync);

    static ConcurrentDictionary&lt;IntPtr, Stub_method_<xsl:value-of select="name"/>&gt; dict = new ConcurrentDictionary&lt;IntPtr, Stub_method_<xsl:value-of select="name"/>&gt;();

    // nerv_stub_command delegate
    public static Int32 on_link(IntPtr _command_, Address _proxy_addr, Double _elapsed, Double _limit)
    {
        Int32 err = dict[_command_].icommand.on_link(_proxy_addr, _elapsed, _limit);
        return err;
    }
    public static void on_unlink(IntPtr _command_, Address _proxy_addr, Int32 _err)
    {
        dict[_command_].icommand.on_unlink(_proxy_addr, _err);
    }
    public static void on_sync(IntPtr _command_, Address _proxy_addr, Sync_model _sync_model, Double _elapsed, Double _limit, IntPtr _cmd_dat_, UInt32 _cmd_size)
    {<xsl:if test="in_data!='(null)'">
        Nerv36.Data<xsl:value-of select="$in_data_domain_namespace"/>.<xsl:value-of select="in_data"/>* cmd_data_ = (Nerv36.Data<xsl:value-of select="$in_data_domain_namespace"/>.<xsl:value-of select="in_data"/>*)_cmd_dat_;
        </xsl:if>
        dict[_command_].icommand.on_sync(_proxy_addr, _sync_model, _elapsed, _limit<xsl:if test="in_data!='(null)'">, ref *cmd_data_</xsl:if>);
    }

    public IntPtr command_;
    public IStub_method_<xsl:value-of select="name"/> icommand;

    public Stub_method_<xsl:value-of select="name"/>(ref Nerv36.Stub _object_, IStub_method_<xsl:value-of select="name"/> _icommand)
    {
        command_ = Nerv36.Stub_command.alloc(<xsl:value-of select="code"/>, _object_.object_, on_sync_, on_link_, on_unlink_);
        dict[command_] = this;
        icommand = _icommand;
    }
    ~Stub_method_<xsl:value-of select="name"/>()
    {
        // Nerv36.Stub_command.free(command_);
        // API.nerv_finalize()에서 정리되지 않은 객체를 자동해제하므로
        // C#에서는 Nerv36.Stub_command.free(command_); 로 정리하지 않는다.
        // C#의 소멸자는 언제 호출될지 알수 없다.

        Stub_method_<xsl:value-of select="name"/> command_reference;
        dict.TryRemove(command_, out command_reference);
    }

    public void unlink(Address _proxy_addr)
    {
        Nerv36.Stub_command.unlink(command_, _proxy_addr);
    }

    public void unlink_all_proxy()
    {
        Nerv36.Stub_command.unlink_all_proxy(command_);
    }

    public void set_sync(Boolean _use_on_sync)
    {
        Nerv36.Stub_command.set_sync(command_, _use_on_sync);
    }

    public IntPtr see_history(Address _proxy_addr, UIntPtr _history_size)
    {
        IntPtr letter_ = Nerv36.Stub_command.see_history(command_, _proxy_addr, _history_size);
        return letter_;
    }

    public void set_history_size(UIntPtr _history_size)
    {
        Nerv36.Stub_command.set_history_size(command_, _history_size);
    }
  <xsl:if test="in_data!='(null)'">
    public Int32 read(Address _proxy_addr, ref Nerv36.Data<xsl:value-of select="$in_data_domain_namespace"/>.<xsl:value-of select="in_data"/> _cmd_dat_)
    {
        UInt32 cmd_size = (UInt32)_cmd_dat_.sizeofall();
        fixed ( Nerv36.Data<xsl:value-of select="$in_data_domain_namespace"/>.<xsl:value-of select="in_data"/>* cmd_data_ = &amp;_cmd_dat_)
        {
            Int32 err = Nerv36.Stub_command.read(command_, _proxy_addr, (IntPtr)cmd_data_, ref cmd_size);
            return err;
        }
    }
  </xsl:if>
}
</xsl:template>


</xsl:stylesheet>
