<?xml version="1.0" encoding="UTF-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="text" encoding="utf-8" indent="yes"/>


<xsl:template name ="template_event" >
  <xsl:variable name="in_data_domain_namespace">
    <xsl:call-template name="get_data_domain_namespace_dot">
      <xsl:with-param name="data_domain_id" select="in_data_domain_id" />
    </xsl:call-template>
  </xsl:variable>
  <xsl:variable name="out_data_domain_namespace">
    <xsl:call-template name="get_data_domain_namespace_dot">
      <xsl:with-param name="data_domain_id" select="out_data_domain_id" />
    </xsl:call-template>
  </xsl:variable>



// proxy
public interface IProxy_method_<xsl:value-of select="name"/>
{
    void on_link(UInt32 _msg_num, Int32 _err, Double _elapsed);
    void on_unlink(Int32 _err);
    void on_event(<xsl:if test="out_data!='(null)'">ref Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/> _evt_dat_,</xsl:if> double _elapsed);
}
public unsafe class Proxy_method_<xsl:value-of select="name"/>
{
    static Nerv36.Proxy_event.on_link_ft on_link_ = new Nerv36.Proxy_event.on_link_ft(on_link);
    static Nerv36.Proxy_event.on_unlink_ft on_unlink_ = new Nerv36.Proxy_event.on_unlink_ft(on_unlink);
    static Nerv36.Proxy_event.on_event_ft on_event_   = new Nerv36.Proxy_event.on_event_ft(on_event);

    static ConcurrentDictionary&lt;IntPtr, Proxy_method_<xsl:value-of select="name"/>&gt; dict = new ConcurrentDictionary&lt;IntPtr, Proxy_method_<xsl:value-of select="name"/>&gt;();

    public static void on_event(IntPtr _event_,  IntPtr _evt_dat_, UInt32 _evt_size, double _elapsed)
    {<xsl:if test="out_data!='(null)'">
        Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/>* evt_data_ = (Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/>*)_evt_dat_;
        </xsl:if>
        dict[_event_].ievent.on_event(<xsl:if test="out_data!='(null)'"> ref *evt_data_,</xsl:if> _elapsed);
    }
    public static void on_link(IntPtr _event_, UInt32 _msg_num, Int32 _err, Double _elapsed)
    {
        dict[_event_].ievent.on_link(_msg_num, _err, _elapsed);
    }

    public static void on_unlink(IntPtr _event_, Int32 _err)
    {
        dict[_event_].ievent.on_unlink(_err);
    }

    public IntPtr event_;
    public IProxy_method_<xsl:value-of select="name"/> ievent;

    public Proxy_method_<xsl:value-of select="name"/>(ref Nerv36.Proxy _object_, IProxy_method_<xsl:value-of select="name"/> _ievent)
    {
        event_ = Nerv36.Proxy_event.alloc(<xsl:value-of select="code"/>, _object_.object_, on_link_, on_unlink_, on_event_);
        dict[event_] = this;
        ievent = _ievent;
    }
    ~Proxy_method_<xsl:value-of select="name"/>()
    {
        // Nerv36.Proxy_event.free(event_);
        // API.nerv_finalize()에서 정리되지 않은 객체를 자동해제하므로
        // C#에서는 Nerv36.Proxy_event.free(event_); 로 정리하지 않는다.
        // C#의 소멸자는 언제 호출될지 알수 없다.

        Proxy_method_<xsl:value-of select="name"/> event_reference;
        dict.TryRemove(event_, out event_reference);
    }

    public Boolean is_linked()
    {
        return Nerv36.Proxy_event.is_linked(event_);
    }

    public Int32 delegate_link(ref UInt32 _msg_num_, Double _limit)
    {
        Int32 err = Nerv36.Proxy_event.delegate_link( event_, ref _msg_num_, _limit);
        return err;
    }

    public IntPtr async_link(Double _limit)
    {
        IntPtr promise_ = Nerv36.Proxy_event.async_link( event_, _limit);
        return promise_;
    }
    public Int32 await_link_return( IntPtr _promise_, ref Double _elapsed_)
    {
        Int32 err = Nerv36.Proxy_event.await_link_return(event_, _promise_, ref _elapsed_);
        return err;
    }
    public Int32 link(Double _limit, ref Double _elapsed_)
    {
        IntPtr promise_ = Nerv36.Proxy_event.async_link( event_, _limit);
        Int32 err = Nerv36.Proxy_event.await_link_return(event_, promise_, ref _elapsed_);
        return err;
    }
    public void unlink()
    {
        Nerv36.Proxy_event.unlink(event_);
    }

}

// stub
public interface IStub_method_<xsl:value-of select="name"/>
{
    Int32 on_link(Address _proxy_addr, Double _elapsed, Double _limit);
    void on_unlink(Address _proxy_addr, Int32 _err);
}

public unsafe class Stub_method_<xsl:value-of select="name"/>
{
    static Nerv36.Stub_event.on_link_ft on_link_     = new Nerv36.Stub_event.on_link_ft(on_link);
    static Nerv36.Stub_event.on_unlink_ft on_unlink_ = new Nerv36.Stub_event.on_unlink_ft(on_unlink);
    static ConcurrentDictionary&lt;IntPtr, Stub_method_<xsl:value-of select="name"/>&gt; dict = new ConcurrentDictionary&lt;IntPtr, Stub_method_<xsl:value-of select="name"/>&gt;();

    // nerv_stub_event delegate
    public static Int32 on_link(IntPtr _event_, Address _proxy_addr, Double _elapsed, Double _limit)
    {
        Int32 err = dict[_event_].ievent.on_link(_proxy_addr, _elapsed, _limit);
        return err;
    }
    public static void on_unlink(IntPtr _event_, Address _proxy_addr, Int32 _err)
    {
        dict[_event_].ievent.on_unlink(_proxy_addr, _err);
    }

    public IntPtr event_;
    public IStub_method_<xsl:value-of select="name"/> ievent;

    public Stub_method_<xsl:value-of select="name"/>(ref Nerv36.Stub _object_, IStub_method_<xsl:value-of select="name"/> _ievent)
    {
        event_ = Nerv36.Stub_event.alloc(<xsl:value-of select="code"/>, _object_.object_, on_link_, on_unlink_);
        dict[event_] = this;
        ievent = _ievent;
    }
    ~Stub_method_<xsl:value-of select="name"/>()
    {
        // Nerv36.Stub_event.free(event_);
        // API.nerv_finalize()에서 정리되지 않은 객체를 자동해제하므로
        // C#에서는 Nerv36.Stub_event.free(event_); 로 정리하지 않는다.
        // C#의 소멸자는 언제 호출될지 알수 없다.

        Stub_method_<xsl:value-of select="name"/> event_reference;
        dict.TryRemove(event_, out event_reference);
    }

    public void unlink(Address _proxy_addr)
    {
        Nerv36.Stub_event.unlink(event_, _proxy_addr);
    }

    public void unlink_all_proxy()
    {
        Nerv36.Stub_event.unlink_all_proxy(event_);
    }

    public Int32 notify(<xsl:if test="out_data!='(null)'">ref Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/> _evt_dat_</xsl:if>)
    {
        <xsl:if test="out_data!='(null)'">
        UInt32 evt_size = (UInt32)_evt_dat_.fit_size();
        fixed ( Nerv36.Data<xsl:value-of select="$out_data_domain_namespace"/>.<xsl:value-of select="out_data"/>* evt_data_ = &amp;_evt_dat_)
        {
            Int32 err = Nerv36.Stub_event.notify(event_, (IntPtr)evt_data_, evt_size);
            return err;
        }
        </xsl:if>
        <xsl:if test="out_data='(null)'">
        Int32 err = Nerv36.Stub_event.notify_nodata(event_);
        return err;
        </xsl:if>
    }
}

</xsl:template>


</xsl:stylesheet>
