<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:include href="../../xsl_util.xsl"/>
<xsl:output method="text" encoding="utf-8" indent="yes" />
<xsl:template match="/">
<xsl:variable name="component_name">
  <xsl:call-template name="replace">
    <xsl:with-param name="text" select="nerv_icde/component/name" />
    <xsl:with-param name="replace" select="' '" />
    <xsl:with-param name="by" select="'_'" />
  </xsl:call-template>
</xsl:variable>
#include "The_<xsl:value-of select="$component_name"/>/The_<xsl:value-of select="$component_name"/>.hh"

#if defined USE_QT &amp;&amp; USE_QT==1
#include "Main_window/Main_window.hpp"
#include &lt;QApplication&gt;
#endif

#include "Main_prompt/Main_prompt.hh"

#include &lt;Waregram/utf8.h&gt;
#include &lt;Waregram/_stdout.hpp&gt;
#include &lt;Waregram/null_filepath.h&gt;
#include &lt;Waregram/Var.hpp&gt;

#include &lt;thread&gt;
#include &lt;stdio.h&gt;
#include &lt;string.h&gt;

namespace <xsl:value-of select="$component_name"/> {

using namespace std;
using namespace std::this_thread;
using namespace std::chrono;
using namespace Waregram;

int main(int argc, char* argv[])
{
    // examout_ = fopen(NULL_FILEPATH, "wt");

    int ret = 0;

    wg_code_page cp_old = begin_utf8();

    Nerv36::initialize();

    printf("<xsl:value-of select="$component_name"/>\n");

    try
    {
        Var&lt;The_<xsl:value-of select="$component_name"/>&gt; <xsl:value-of select="$component_name"/>_;
        The_<xsl:value-of select="$component_name"/>&amp; <xsl:value-of select="$component_name"/> = *<xsl:value-of select="$component_name"/>_;
        const char* display_ = getenv("DISPLAY");
        if( display_ == 0 ) {
            // 반복 순환문으로 동작하는 상태기계를 실행시킨다.
            <xsl:value-of select="$component_name"/>.state_machine_ = (std::thread*)(-1);
            <xsl:value-of select="$component_name"/>.state_machine();
            // 반복 순환문으로 동작하는 상태기계를 정지시킨다.
            <xsl:value-of select="$component_name"/>.state_machine_ = (std::thread*)(0);
        }
        else if( strcmp(display_,"prompt") == 0 ) {
            printf("$DISPLAY is \"prompt\".\n");
            Var&lt;Main_prompt&gt; main_prompt_(ref(argc), argv,&amp;<xsl:value-of select="$component_name"/>);
            Main_prompt&amp; main_prompt = *main_prompt_;
            // 반복 순환문으로 동작하는 상태기계를 실행시킨다.
            <xsl:value-of select="$component_name"/>.start_state_machine();
            int r = main_prompt.exec();
            // 반복 순환문으로 동작하는 상태기계를 정지시킨다.
            <xsl:value-of select="$component_name"/>.stop_state_machine();
        }
        else {
#if defined USE_QT &amp;&amp; USE_QT==1
            printf("DISPLAY is %s.\nIt shall run Qt GUI.", display_);
            Var&lt;QApplication&gt; qapp_(ref(argc), argv);
            QApplication&amp; qapp = *qapp_;
            Var&lt;Main_window&gt;  main_window_(&amp;<xsl:value-of select="$component_name"/>);
            Main_window&amp; main_window = *main_window_;
            main_window.show();
            // 반복 순환문으로 동작하는 상태기계를 실행시킨다.
            <xsl:value-of select="$component_name"/>.start_state_machine();
            int r = qapp.exec();
            // 반복 순환문으로 동작하는 상태기계를 정지시킨다.
            <xsl:value-of select="$component_name"/>.stop_state_machine();
#else
            // 반복 순환문으로 동작하는 상태기계를 실행시킨다.
            <xsl:value-of select="$component_name"/>.state_machine_ = (std::thread*)(-1);
            <xsl:value-of select="$component_name"/>.state_machine();
            // 반복 순환문으로 동작하는 상태기계를 정지시킨다.
            <xsl:value-of select="$component_name"/>.state_machine_ = (std::thread*)(0);
#endif
        }
    }
    catch(int _e)
    {
        ret = _e;
    }
    catch(...)
    {
        ret = -1;
    }

    Nerv36::finalize();

    end_utf8(cp_old);

    return ret;
}

} // namespace <xsl:value-of select="$component_name"/>

</xsl:template>
</xsl:stylesheet>
