<?xml version="1.0" encoding="UTF-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="text" encoding="utf-8" indent="yes"/>



<xsl:template name ="template_event" >
  <xsl:variable name="in_data_domain_namespace">
    <xsl:call-template name="get_data_domain_namespace">
      <xsl:with-param name="data_domain_id" select="in_data_domain_id" />
    </xsl:call-template>
  </xsl:variable>
  <xsl:variable name="out_data_domain_namespace">
    <xsl:call-template name="get_data_domain_namespace">
      <xsl:with-param name="data_domain_id" select="out_data_domain_id" />
    </xsl:call-template>
  </xsl:variable>



// proxy
struct Proxy_method_<xsl:value-of select="name"/>_ {
    virtual void on_<xsl:value-of select="name"/>_link(Msg_num _msg_num, Error _err, double _elapsed) = 0;
    virtual void on_<xsl:value-of select="name"/>_unlink(Error _err) = 0;
    virtual void on_<xsl:value-of select="name"/>(<xsl:if test="out_data!='(null)'"> const Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>* _evt_dat_,</xsl:if> double _elapsed) = 0;
};

class Proxy_method_<xsl:value-of select="name"/> : public Nerv36::Proxy_event {

    virtual void on_event( const void* _evt_dat_, Pksize _evt_size, double _elapsed)
    {
        interface_-&gt;on_<xsl:value-of select="name"/>(<xsl:if test="out_data!='(null)'"> (const Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>*)_evt_dat_,</xsl:if> _elapsed);
    }
    virtual void on_link( Msg_num _msg_num, Error _err, double _elapsed)
    {
        interface_-&gt;on_<xsl:value-of select="name"/>_link(_msg_num, _err, _elapsed);
    }
    virtual void on_unlink(Error _err)
    {
        interface_-&gt;on_<xsl:value-of select="name"/>_unlink(_err);
    }

public:
    Proxy_method_<xsl:value-of select="name"/>_* interface_;

    Proxy_method_<xsl:value-of select="name"/>(
        const Proxy&amp; _proxy_,
        Proxy_method_<xsl:value-of select="name"/>_* _interface_)
        : Proxy(_proxy_)
        , Proxy_event(<xsl:value-of select="code"/>, _proxy_)
        , interface_(_interface_)
    {
    }

    ~Proxy_method_<xsl:value-of select="name"/>()
    {
    }

    Error link( double _limit, double* _elapsed_ = 0)
    {
        Promise* promise_ = Proxy_event::async_link(_limit);
        Error err = Proxy_event::await_link_return(promise_, _elapsed_);
        return err;
    }
};

// stub
struct Stub_method_<xsl:value-of select="name"/>_ {
    virtual Error on_<xsl:value-of select="name"/>_link(Address   _proxy_addr,
                                                  double _elapsed,
                                                  double _limit) = 0;
    virtual void on_<xsl:value-of select="name"/>_unlink(Address _proxy_addr, Error _err) = 0;
};

class Stub_method_<xsl:value-of select="name"/> : public Stub_event {

    virtual Error on_link( Address _proxy_addr,
                                double      _elapsed,
                                double      _limit )
    {
        return interface_-&gt;on_<xsl:value-of select="name"/>_link( _proxy_addr, _elapsed, _limit );
    }

    virtual void on_unlink( Address _proxy_addr, Error _err)
    {
        interface_-&gt;on_<xsl:value-of select="name"/>_unlink(_proxy_addr, _err);
    }

public:
    Stub_method_<xsl:value-of select="name"/>_* interface_;

    Stub_method_<xsl:value-of select="name"/>(
        const Stub&amp; _stub_,
        Stub_method_<xsl:value-of select="name"/>_* _interface_)
        : Stub(_stub_)
        , Stub_event(<xsl:value-of select="code"/>, _stub_)
        , interface_(_interface_)
    {
    }

    ~Stub_method_<xsl:value-of select="name"/>()
    {
    }

    <xsl:if test="out_data!='(null)'">
    Error notify(const Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>* _evt_dat_)
    {
        Error err;
        ::Nerv36::Pksize evt_size = _evt_dat_-&gt;fit_size();
        if( evt_size &lt; sizeof(Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>) ) {
            err = NERV_ERR_UNUSED_DYNAMIC_BUFFER_;
        }
        else {
            err = Nerv36::Stub_event::notify( _evt_dat_, evt_size);
        }
        return err;
    }
    </xsl:if>
    <xsl:if test="out_data='(null)'">
    Error notify()
    {
        Error err = Nerv36::Stub_event::notify();
        return err;
    }
    </xsl:if>
};

</xsl:template>



</xsl:stylesheet>
