<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:include href="../../../xsl_util.xsl"/>
<xsl:output method="text" encoding="utf-8" indent="yes" />
<xsl:template match="/">
<xsl:variable name="component_name">
  <xsl:call-template name="replace">
    <xsl:with-param name="text" select="nerv_icde/component/name" />
    <xsl:with-param name="replace" select="' '" />
    <xsl:with-param name="by" select="'_'" />
  </xsl:call-template>
</xsl:variable>
#pragma once

<xsl:for-each select="/nerv_icde/component/proxy_list/row">
#include "Nerv_proxy/<xsl:value-of select="class_name"/>_exam/<xsl:value-of select="class_name"/>_exam.hh"
</xsl:for-each>
<xsl:for-each select="/nerv_icde/component/stub_list/row">
#include "Nerv_stub/<xsl:value-of select="class_name"/>_exam/<xsl:value-of select="class_name"/>_exam.hh"
</xsl:for-each>

#include &lt;Nerv36/Data/Component/Component.hh&gt;

#include &lt;stack&gt;
#include &lt;thread&gt;


namespace Exam {

// using namespace std;
using namespace std::this_thread;
using namespace std::chrono;
using namespace Nerv36::Data::Component;

class Exam_<xsl:value-of select="$component_name"/> {
public:
    Exam_<xsl:value-of select="$component_name"/>();
    ~Exam_<xsl:value-of select="$component_name"/>();

  <xsl:for-each select="/nerv_icde/component/proxy_list/row/object_list/row">
    static const char conn_<xsl:value-of select="object_name"/>[];
    static const char not_conn_<xsl:value-of select="object_name"/>[];
  </xsl:for-each>
  <xsl:for-each select="/nerv_icde/component/proxy_list/row/object_list/row">
    const char* err_<xsl:value-of select="object_name"/>_conn_;
  </xsl:for-each>

protected:
  <xsl:for-each select="/nerv_icde/component/stub_list/row/object_list/row">
<xsl:text>
    </xsl:text>Nerv_stub::<xsl:value-of select="../../class_name"/>_exam*<xsl:text> </xsl:text>stub_<xsl:value-of select="object_name"/>_;<xsl:text/>
  </xsl:for-each>
  <xsl:for-each select="/nerv_icde/component/proxy_list/row/object_list/row">
<xsl:text>
    </xsl:text>Nerv_proxy::<xsl:value-of select="../../class_name"/>_exam*<xsl:text> </xsl:text>proxy_<xsl:value-of select="object_name"/>_;<xsl:text/>
  </xsl:for-each>

    virtual void start_stub();
    virtual void start_proxy();

    virtual void stop_stub();
    virtual void stop_proxy();

  <xsl:for-each select="/nerv_icde/component/proxy_list/row/object_list/row">
    <xsl:variable name="method_domain_id" select="../../method_domain_id" />
    <xsl:variable name="interface_name" select="../../interface_name" />
    <xsl:variable name="object_name" select="object_name" />
    <xsl:for-each select="/nerv_icde/methoddomain/row[id=$method_domain_id]">
      <xsl:for-each select="interface/row[name=$interface_name]">
        <xsl:for-each select="membermethod/row">
          <xsl:variable name="method_name" select="method_name" />
          <xsl:for-each select="../../../../method/row[name=$method_name]">
            <xsl:if test="type='INFORMATION' and out_data!='(null)'">
              <xsl:variable name="out_data_domain_namespace">
                <xsl:call-template name="get_data_domain_namespace">
                  <xsl:with-param name="data_domain_id" select="out_data_domain_id" />
                </xsl:call-template>
              </xsl:variable>
    virtual void read_<xsl:value-of select="$object_name"/>_<xsl:value-of select="$method_name"/>();
            </xsl:if>
          </xsl:for-each>
        </xsl:for-each>
      </xsl:for-each>
    </xsl:for-each>
  </xsl:for-each>

    virtual void read_from_proxy();
  <xsl:for-each select="/nerv_icde/component/proxy_list/row/object_list/row">
    <xsl:variable name="method_domain_id" select="../../method_domain_id" />
    <xsl:variable name="interface_name" select="../../interface_name" />
    <xsl:variable name="object_name" select="object_name" />
    <xsl:for-each select="/nerv_icde/methoddomain/row[id=$method_domain_id]">
      <xsl:for-each select="interface/row[name=$interface_name]">
        <xsl:for-each select="membermethod/row">
          <xsl:variable name="method_name" select="method_name" />
          <xsl:for-each select="../../../../method/row[name=$method_name]">
            <xsl:variable name="in_data_domain_namespace">
              <xsl:call-template name="get_data_domain_namespace">
                <xsl:with-param name="data_domain_id" select="in_data_domain_id"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="out_data_domain_namespace">
              <xsl:call-template name="get_data_domain_namespace">
                <xsl:with-param name="data_domain_id" select="out_data_domain_id"/>
              </xsl:call-template>
            </xsl:variable>
            <!-- <xsl:variable name="in_data_domain_namespace_dot" select="substring($in_data_domain_namespace,2)"/>
            <xsl:variable name="out_data_domain_namespace_dot" select="substring($out_data_domain_namespace,2)"/> -->
            <xsl:choose>
              <xsl:when test="type='CALL'">
    virtual void <xsl:value-of select="$object_name"/>_<xsl:value-of select="$method_name"/>_call();
              </xsl:when>
              <xsl:when test="type='SIGNAL'">
    virtual void <xsl:value-of select="$object_name"/>_<xsl:value-of select="$method_name"/>_signal();
              </xsl:when>
              <xsl:when test="type='COMMAND'">
    virtual void <xsl:value-of select="$object_name"/>_<xsl:value-of select="$method_name"/>_command();
              </xsl:when>
            </xsl:choose>
          </xsl:for-each>
        </xsl:for-each>
      </xsl:for-each>
    </xsl:for-each>
  </xsl:for-each>

    virtual void send_from_proxy();
  <xsl:for-each select="/nerv_icde/component/stub_list/row/object_list/row">
    <xsl:variable name="method_domain_id" select="../../method_domain_id" />
    <xsl:variable name="interface_name" select="../../interface_name" />
    <xsl:variable name="object_name" select="object_name" />
    <xsl:for-each select="/nerv_icde/methoddomain/row[id=$method_domain_id]">
      <xsl:for-each select="interface/row[name=$interface_name]">
        <xsl:for-each select="membermethod/row">
          <xsl:variable name="method_name" select="method_name" />
          <xsl:for-each select="../../../../method/row[name=$method_name]">
            <xsl:variable name="in_data_domain_namespace">
              <xsl:call-template name="get_data_domain_namespace">
                <xsl:with-param name="data_domain_id" select="in_data_domain_id"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="out_data_domain_namespace">
              <xsl:call-template name="get_data_domain_namespace">
                <xsl:with-param name="data_domain_id" select="out_data_domain_id"/>
              </xsl:call-template>
            </xsl:variable>
            <!-- <xsl:variable name="in_data_domain_namespace_dot" select="substring($in_data_domain_namespace,2)"/>
            <xsl:variable name="out_data_domain_namespace_dot" select="substring($out_data_domain_namespace,2)"/> -->
            <xsl:choose>
              <xsl:when test="type='CALLBACK'">
    virtual void <xsl:value-of select="$object_name"/>_<xsl:value-of select="$method_name"/>_callback();
              </xsl:when>
              <xsl:when test="type='SIGNALBACK'">
    virtual void <xsl:value-of select="$object_name"/>_<xsl:value-of select="$method_name"/>_signalback();
              </xsl:when>
              <xsl:when test="type='EVENT'">
    virtual void <xsl:value-of select="$object_name"/>_<xsl:value-of select="$method_name"/>_event();
              </xsl:when>
              <xsl:when test="type='INFORMATION'">
    virtual void <xsl:value-of select="$object_name"/>_<xsl:value-of select="$method_name"/>_information();
              </xsl:when>

              <xsl:when test="type='BROADCAST'">
    virtual void <xsl:value-of select="$object_name"/>_<xsl:value-of select="$method_name"/>_datagram();
              </xsl:when>
            </xsl:choose>
          </xsl:for-each>
        </xsl:for-each>
      </xsl:for-each>
    </xsl:for-each>
  </xsl:for-each>
  <xsl:for-each select="/nerv_icde/component/stub_list/row/object_list/row">
    <xsl:variable name="method_domain_id" select="../../method_domain_id" />
    <xsl:variable name="interface_name" select="../../interface_name" />
    <xsl:variable name="object_name" select="object_name" />
    <xsl:for-each select="/nerv_icde/methoddomain/row[id=$method_domain_id]">
      <xsl:for-each select="interface/row[name=$interface_name]">
        <xsl:for-each select="membermethod/row">
          <xsl:variable name="method_name" select="method_name" />
          <xsl:for-each select="../../../../method/row[name=$method_name]">
            <xsl:if test="type='COMMAND' and in_data!='(null)'">
              <xsl:variable name="data_domain_namespace">
                <xsl:call-template name="get_data_domain_namespace">
                  <xsl:with-param name="data_domain_id" select="in_data_domain_id" />
                </xsl:call-template>
              </xsl:variable>
    virtual void read_<xsl:value-of select="$object_name"/>_<xsl:value-of select="$method_name"/>();
            </xsl:if>
          </xsl:for-each>
        </xsl:for-each>
      </xsl:for-each>
    </xsl:for-each>
  </xsl:for-each>
    virtual void read_from_stub();
    virtual void send_from_stub();
public:
    Nerv36::Data::Component::Component_state* state_;

protected:
    size_t cnt;

    int interval_ns;
    int interval_sec;
    bool nonsleep;

    void set_state(State _state);

    virtual void on_finalize();
    virtual void on_initialize();
    virtual void on_idle();
    virtual void on_shutdown();
    virtual void on_ready();
    virtual void on_standby();
    virtual void on_stop();
    virtual void on_start();
    virtual void on_run();

    virtual void on_failure();

    virtual void on_emergency();
    virtual void on_emergency_rising_edge();
    virtual void on_release_falling_edge();

    virtual void on_failure_check();
    virtual Error failure_check();

public:
    std::thread* state_machine_;

    void start_state_machine();
    void stop_state_machine();

    virtual void frequency(int _hz);
    virtual void interval(int _sec);

    virtual void state_machine();
    virtual void state_cycle();

public:
    virtual void failure(Error _error);

    virtual void terminate();
    virtual void finalize();
    virtual void initialize();
    virtual void idle();
    virtual void shutdown();
    virtual void ready();
    virtual void standby();
    virtual void stop();
    virtual void start();
    virtual void run();

    virtual void trans_terminate();
    virtual void trans_finalize();
    virtual void trans_initialize();
    virtual void trans_idle();
    virtual void trans_shutdown();
    virtual void trans_ready();
    virtual void trans_standby();
    virtual void trans_stop();
    virtual void trans_start();
    virtual void trans_run();

    virtual void reset();

    virtual void emergency();
    virtual void release();

    virtual void notify_state();
};

} // namespace Exam

</xsl:template>
</xsl:stylesheet>
