<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:include href="../xsl_util.xsl"/>
<xsl:output method="text" encoding="utf-8" indent="yes" />
<xsl:template match="/">
<xsl:variable name="component_name">
  <xsl:call-template name="replace">
    <xsl:with-param name="text" select="nerv_icde/component/name" />
    <xsl:with-param name="replace" select="' '" />
    <xsl:with-param name="by" select="'_'" />
  </xsl:call-template>
</xsl:variable>
import time
import threading
import signal
import sys
import py_nerv36 as nerv
from py_nerv36 import Data as nstt # Nerv struct
import py_nerv36_print_data as nprint
import py_nerv36_set_data as nset
import py_nerv36_thread


  <xsl:for-each select="/nerv_icde/component/stub_list/row">
from <xsl:value-of select="class_name"/> import <xsl:value-of select="class_name"/>
  </xsl:for-each>
  <xsl:for-each select="/nerv_icde/component/proxy_list/row">
from <xsl:value-of select="class_name"/> import <xsl:value-of select="class_name"/>
  </xsl:for-each>

class cNerv_Component_<xsl:value-of select="$component_name"/>():

    def __init__(self):
        print("<xsl:value-of select="$component_name"/>.__init__()")
        self.a = 0

        # create 전에 모든 객체를 생성해야 합니다.
  <xsl:for-each select="/nerv_icde/component/stub_list/row/object_list/row">
<xsl:text>
        </xsl:text>self.stub_<xsl:value-of select="object_name"/> = <xsl:value-of select="../../class_name"/>()<xsl:text/>
  </xsl:for-each>
  <xsl:for-each select="/nerv_icde/component/proxy_list/row/object_list/row">
<xsl:text>
        </xsl:text>self.proxy_<xsl:value-of select="object_name"/> = <xsl:value-of select="../../class_name"/>()<xsl:text/>
  </xsl:for-each>
        pass

    def __del__(self):
  <xsl:for-each select="/nerv_icde/component/stub_list/row/object_list/row">
<xsl:text>
        </xsl:text>if self.stub_<xsl:value-of select="object_name"/>.is_started():
            self.stub_<xsl:value-of select="object_name"/>.stop()
        del self.stub_<xsl:value-of select="object_name"/><xsl:text/>
  </xsl:for-each>
  <xsl:for-each select="/nerv_icde/component/proxy_list/row/object_list/row">
<xsl:text>
        </xsl:text>if self.proxy_<xsl:value-of select="object_name"/>.is_started():
            self.proxy_<xsl:value-of select="object_name"/>.stop()
        del self.proxy_<xsl:value-of select="object_name"/><xsl:text/>
  </xsl:for-each>
        pass

    def proxy_read(self):

  <xsl:for-each select="/nerv_icde/component/proxy_list/row/object_list/row">
    <xsl:variable name="method_domain_id" select="../../method_domain_id" />
    <xsl:variable name="interface_name" select="../../interface_name" />
    <xsl:variable name="object_name" select="object_name" />

    <xsl:for-each select="/nerv_icde/methoddomain/row[id=$method_domain_id]">
      <xsl:for-each select="interface/row[name=$interface_name]">
        <xsl:for-each select="membermethod/row">
          <xsl:variable name="method_name" select="method_name" />
          <xsl:for-each select="../../../../method/row[name=$method_name]">
            <xsl:variable name="out_data_domain_id" select="out_data_domain_id"/>
            <xsl:variable name="out_data" select="out_data"/>
            <xsl:variable name="in_data_domain_id" select="in_data_domain_id"/>
            <xsl:variable name="in_data" select="in_data"/>
            <xsl:variable name="in_domain_namespace_dot">
              <xsl:call-template name="get_data_domain_namespace_dot">
                <xsl:with-param name="data_domain_id" select="in_data_domain_id" />
                <xsl:with-param name="data" select="in_data" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="out_domain_namespace_dot">
              <xsl:call-template name="get_data_domain_namespace_dot">
                <xsl:with-param name="data_domain_id" select="out_data_domain_id" />
                <xsl:with-param name="data" select="in_data" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:if test="type='INFORMATION' and out_data!='(null)'">
              <xsl:variable name="data"><xsl:value-of select="$out_data"/></xsl:variable>
<xsl:text>

        </xsl:text><xsl:value-of select="$data"/> = nstt<xsl:value-of select="$out_domain_namespace_dot"/>.<xsl:value-of select="out_data"/>.malloc(65536)<xsl:text/>
<xsl:text>
        err = self.proxy_</xsl:text><xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_read(<xsl:value-of select="$data"/>)
        print("proxy_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_read() = ", nerv.get_err_str(err))
        if not err:
            nprint.<xsl:value-of select="out_data_domain"/>_<xsl:value-of select="out_data"/>(<xsl:value-of select="out_data"/>)
            print(flush=True)
        <xsl:value-of select="$data"/>.free()<xsl:text/>
            </xsl:if>
          </xsl:for-each>
        </xsl:for-each>
      </xsl:for-each>
    </xsl:for-each>
  </xsl:for-each>
        pass

    def stub_send(self):
        msg_num_ref = nerv.Msg_num_ref()
  <xsl:for-each select="/nerv_icde/component/stub_list/row/object_list/row">
    <xsl:variable name="method_domain_id" select="../../method_domain_id" />
    <xsl:variable name="interface_name" select="../../interface_name" />
    <xsl:variable name="object_name" select="object_name" />

    <xsl:for-each select="/nerv_icde/methoddomain/row[id=$method_domain_id]">
      <xsl:for-each select="interface/row[name=$interface_name]">
        <xsl:for-each select="membermethod/row">
          <xsl:variable name="method_name" select="method_name" />
          <xsl:for-each select="../../../../method/row[name=$method_name]">
            <xsl:variable name="out_data_domain_id" select="out_data_domain_id"/>
            <xsl:variable name="out_data" select="out_data"/>
            <xsl:variable name="in_data_domain_id" select="in_data_domain_id"/>
            <xsl:variable name="in_data" select="in_data"/>
            <xsl:variable name="in_domain_namespace_dot">
              <xsl:call-template name="get_data_domain_namespace_dot">
                <xsl:with-param name="data_domain_id" select="in_data_domain_id" />
                <xsl:with-param name="data" select="in_data" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="out_domain_namespace_dot">
              <xsl:call-template name="get_data_domain_namespace_dot">
                <xsl:with-param name="data_domain_id" select="out_data_domain_id" />
                <xsl:with-param name="data" select="in_data" />
              </xsl:call-template>
            </xsl:variable>


            <xsl:if test="type='CALLBACK' or type='SIGNALBACK' or type='EVENT' or type='INFORMATION' or type='BROADCAST'">
              <xsl:variable name="data">out_data_<xsl:value-of select="position()"/></xsl:variable>
              <xsl:if test="out_data!='(null)'">
<xsl:text>
        </xsl:text><xsl:value-of select="$data"/> = nstt<xsl:value-of select="$out_domain_namespace_dot"/>.<xsl:value-of select="out_data"/>.malloc(65536)
        nset.<xsl:value-of select="out_data_domain"/>_<xsl:value-of select="out_data"/>(<xsl:value-of select="$data"/>, self.a)<xsl:text/>
              </xsl:if>
              <xsl:choose>
                <xsl:when test="type='CALLBACK'">
                  <xsl:if test="out_data='(null)' and in_data='(null)'">
<xsl:text>
        </xsl:text>err = self.stub_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_delegate_callback(msg_num_ref, self.stub_<xsl:value-of select="$object_name"/>.proxy_addr, 1.0)
        print("stub_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_delegate_callback(%d) = " % (msg_num_ref.ref), nerv.get_err_str(err) )<xsl:text/>
                  </xsl:if>
                  <xsl:if test="out_data!='(null)' and in_data='(null)'">
<xsl:text>
        </xsl:text>err = self.stub_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_delegate_callback(msg_num_ref, self.stub_<xsl:value-of select="$object_name"/>.proxy_addr, <xsl:value-of select="$data"/>, 1.0)
        print("stub_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_delegate_callback(%d) = " % (msg_num_ref.ref), nerv.get_err_str(err) )
                  </xsl:if>
                  <xsl:if test="out_data='(null)' and in_data!='(null)'">
<xsl:text>
        </xsl:text>err = self.stub_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_delegate_callback(msg_num_ref, self.stub_<xsl:value-of select="$object_name"/>.proxy_addr, 1.0)
        print("stub_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_delegate_callback(%d) = " % (msg_num_ref.ref), nerv.get_err_str(err) )<xsl:text/>
                  </xsl:if>
                  <xsl:if test="out_data!='(null)' and in_data!='(null)'">
<xsl:text>
        </xsl:text>err = self.stub_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_delegate_callback(msg_num_ref, self.stub_<xsl:value-of select="$object_name"/>.proxy_addr, <xsl:value-of select="$data"/>, 1.0)
        print("stub_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_delegate_callback(%d) = " % (msg_num_ref.ref), nerv.get_err_str(err) )
                  </xsl:if>
                </xsl:when>
                <xsl:when test="type='SIGNALBACK'">
                  <xsl:if test="out_data='(null)'">
<xsl:text>
        </xsl:text>err = self.stub_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_delegate_signalback(msg_num_ref, self.stub_<xsl:value-of select="$object_name"/>.proxy_addr, 1.0)
        print("stub_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>(%d) = " % (msg_num_ref.ref), nerv.get_err_str(err))<xsl:text/>
                  </xsl:if>
                  <xsl:if test="out_data!='(null)'">
<xsl:text>
        </xsl:text>err = self.stub_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_delegate_signalback(msg_num_ref, self.stub_<xsl:value-of select="$object_name"/>.proxy_addr, <xsl:value-of select="$data"/>, 1.0)
        print("stub_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>(%d) = " % (msg_num_ref.ref), nerv.get_err_str(err) )
                  </xsl:if>
                </xsl:when>
                <xsl:when test="type='EVENT'">
                  <xsl:if test="out_data='(null)'">
<xsl:text>
        </xsl:text>err = self.stub_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>()
        print("stub_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>() = ", nerv.get_err_str(err))<xsl:text/>
                  </xsl:if>
                  <xsl:if test="out_data!='(null)'">
<xsl:text>
        </xsl:text>err = self.stub_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>(<xsl:value-of select="$data"/>)
        print("stub_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>() = ", nerv.get_err_str(err))<xsl:text/>
                  </xsl:if>
                </xsl:when>
                <xsl:when test="type='INFORMATION'">
                  <xsl:if test="out_data='(null)'">
<xsl:text>
        </xsl:text>err = self.stub_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_write()
        print("stub_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_write() = ", nerv.get_err_str(err))<xsl:text/>
                  </xsl:if>
                  <xsl:if test="out_data!='(null)'">
<xsl:text>
        </xsl:text>err = self.stub_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_write(<xsl:value-of select="$data"/>)
        print("stub_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_write() = ", nerv.get_err_str(err))<xsl:text/>
                  </xsl:if>
                </xsl:when>
                <xsl:when test="type='BROADCAST'">
                  <xsl:if test="out_data='(null)'">
<xsl:text>
        </xsl:text>err = self.stub_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_broadcast()
        print("stub_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_broadcast() = ", nerv.get_err_str(err))<xsl:text/>
                  </xsl:if>
                  <xsl:if test="out_data!='(null)'">
<xsl:text>
        </xsl:text>err = self.stub_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_broadcast(<xsl:value-of select="$data"/>)
        print("stub_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_broadcast() = ", nerv.get_err_str(err))<xsl:text/>
                  </xsl:if>
                </xsl:when>
              </xsl:choose>
              <xsl:if test="out_data!='(null)'">
        nprint.<xsl:value-of select="out_data_domain"/>_<xsl:value-of select="out_data"/>(<xsl:value-of select="$data"/>)
        print(flush=True)
        <xsl:value-of select="$data"/>.free()<xsl:text/>
              </xsl:if>
            </xsl:if>
          </xsl:for-each>
        </xsl:for-each>
      </xsl:for-each>
    </xsl:for-each>
  </xsl:for-each>
        pass

    def proxy_send(self):
        msg_num_ref = nerv.Msg_num_ref()
  <xsl:for-each select="/nerv_icde/component/proxy_list/row/object_list/row">
    <xsl:variable name="method_domain_id" select="../../method_domain_id" />
    <xsl:variable name="interface_name" select="../../interface_name" />
    <xsl:variable name="object_name" select="object_name" />

    <xsl:for-each select="/nerv_icde/methoddomain/row[id=$method_domain_id]">
      <xsl:for-each select="interface/row[name=$interface_name]">
        <xsl:for-each select="membermethod/row">
          <xsl:variable name="method_name" select="method_name" />
          <xsl:for-each select="../../../../method/row[name=$method_name]">
            <xsl:variable name="in_domain_namespace_dot">
              <xsl:call-template name="get_data_domain_namespace_dot">
                <xsl:with-param name="data_domain_id" select="in_data_domain_id" />
                <xsl:with-param name="data" select="in_data" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="out_domain_namespace_dot">
              <xsl:call-template name="get_data_domain_namespace_dot">
                <xsl:with-param name="data_domain_id" select="out_data_domain_id" />
                <xsl:with-param name="data" select="in_data" />
              </xsl:call-template>
            </xsl:variable>
            <xsl:choose>
              <xsl:when test="type='CALL'">
                <xsl:if test="in_data='(null)' and out_data='(null)'">
<xsl:text>
        </xsl:text>err = self.proxy_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_delegate_call(msg_num_ref, 1.0)
        print("proxy_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_delegate_call(%d) = " % (msg_num_ref.ref), nerv.get_err_str(err) )<xsl:text/>
                </xsl:if>
                <xsl:if test="in_data!='(null)' and out_data='(null)'">
                  <xsl:variable name="data">in_data_<xsl:value-of select="position()"/></xsl:variable>
<xsl:text>
        </xsl:text><xsl:value-of select="$data"/> = nstt<xsl:value-of select="$in_domain_namespace_dot"/>.<xsl:value-of select="in_data"/>.malloc(65536)
        nset.<xsl:value-of select="in_data_domain"/>_<xsl:value-of select="in_data"/>(<xsl:value-of select="$data"/>, self.a)<xsl:text/>
<xsl:text>
        </xsl:text>err = self.proxy_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_delegate_call(msg_num_ref, <xsl:value-of select="$data"/>, 1.0)
        print("proxy_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_delegate_call(%d) = " % (msg_num_ref.ref), nerv.get_err_str(err) )
        <xsl:value-of select="$data"/>.free()<xsl:text/>
                </xsl:if>

                <xsl:if test="in_data='(null)' and out_data!='(null)'">
                  <xsl:variable name="data">in_data_<xsl:value-of select="position()"/></xsl:variable>
<xsl:text>
        </xsl:text>err = self.proxy_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_delegate_call(msg_num_ref, 1.0)
        print("proxy_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_delegate_call(%d) = " % (msg_num_ref.ref), nerv.get_err_str(err) )<xsl:text/>
                </xsl:if>

                <xsl:if test="in_data!='(null)' and out_data!='(null)'">
                  <xsl:variable name="in_data">in_data_<xsl:value-of select="position()"/></xsl:variable>
<xsl:text>
        </xsl:text><xsl:value-of select="$in_data"/> = nstt<xsl:value-of select="$in_domain_namespace_dot"/>.<xsl:value-of select="in_data"/>.malloc(65536)
        nset.<xsl:value-of select="in_data_domain"/>_<xsl:value-of select="in_data"/>(<xsl:value-of select="$in_data"/>, self.a)<xsl:text/>
<xsl:text>
        </xsl:text>err = self.proxy_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_delegate_call(msg_num_ref, <xsl:value-of select="$in_data"/>, 1.0)
        print("proxy_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_delegate_call(%d) = " % (msg_num_ref.ref), nerv.get_err_str(err) )
        <xsl:value-of select="$in_data"/>.free()<xsl:text/>
                </xsl:if>
              </xsl:when>
              <xsl:when test="type='SIGNAL'">
                <xsl:if test="in_data='(null)'">
<xsl:text>
        </xsl:text>err = self.proxy_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_delegate_signal(msg_num_ref,  1.0)
        print("proxy_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>(%d) = " % (msg_num_ref.ref), nerv.get_err_str(err))<xsl:text/>
                </xsl:if>
                <xsl:if test="in_data!='(null)'">
                  <xsl:variable name="data">in_data_<xsl:value-of select="position()"/></xsl:variable>
<xsl:text>
        </xsl:text><xsl:value-of select="$data"/> = nstt<xsl:value-of select="$in_domain_namespace_dot"/>.<xsl:value-of select="in_data"/>.malloc(65536)
        nset.<xsl:value-of select="in_data_domain"/>_<xsl:value-of select="in_data"/>(<xsl:value-of select="$data"/>, self.a)<xsl:text/>
<xsl:text>
        </xsl:text>err = self.proxy_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_delegate_signal(msg_num_ref, <xsl:value-of select="$data"/>, 1.0)
        print("proxy_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>(%d) = " % (msg_num_ref.ref), nerv.get_err_str(err) )
        <xsl:value-of select="$data"/>.free()<xsl:text/>
                </xsl:if>
              </xsl:when>
              <xsl:when test="type='COMMAND'">
                <xsl:if test="in_data='(null)'">
<xsl:text>
        </xsl:text>err = self.proxy_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_write()
        print("proxy_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_write() = ", nerv.get_err_str(err) )<xsl:text/>
                </xsl:if>
                <xsl:if test="in_data!='(null)'">
                  <xsl:variable name="data">in_data_<xsl:value-of select="position()"/></xsl:variable>
<xsl:text>
        </xsl:text><xsl:value-of select="$data"/> = nstt<xsl:value-of select="$in_domain_namespace_dot"/>.<xsl:value-of select="in_data"/>.malloc(65536)
        nset.<xsl:value-of select="in_data_domain"/>_<xsl:value-of select="in_data"/>(<xsl:value-of select="$data"/>, self.a)<xsl:text/>
<xsl:text>
        </xsl:text>err = self.proxy_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_write(<xsl:value-of select="$data"/>)
        print("proxy_<xsl:value-of select="$object_name"/>.<xsl:value-of select="$method_name"/>_write() = ", nerv.get_err_str(err) )
        <xsl:value-of select="$data"/>.free()<xsl:text/>
                </xsl:if>
              </xsl:when>
            </xsl:choose>
          </xsl:for-each>
        </xsl:for-each>
      </xsl:for-each>
    </xsl:for-each>
  </xsl:for-each>
        pass

    def Start(self):
        print("<xsl:value-of select="$component_name"/>.start_stub()")

        # 모든 객체를 생성한 이후에 create 할수 있습니다.

        # stub 객체 start
  <xsl:for-each select="/nerv_icde/component/stub_list/row/object_list/row">
<xsl:text>
        </xsl:text>port = nerv.get_<xsl:value-of select="../../method_domain_name"/>_port()<xsl:text/>
<xsl:text>
        </xsl:text>err = self.stub_<xsl:value-of select="object_name"/>.start("<xsl:value-of select="object_name"/>", port)<xsl:text/>
  </xsl:for-each>

        # proxy 객체 start
  <xsl:for-each select="/nerv_icde/component/proxy_list/row/object_list/row">
<xsl:text>
        </xsl:text>
        err = self.proxy_<xsl:value-of select="object_name"/>.start("<xsl:value-of select="object_name"/>")<xsl:text/>
  </xsl:for-each>
        pass

    def Update(self):
        print("<xsl:value-of select="$component_name"/>.Update()")
        self.a = self.a + 1
        self.a = self.a % 8

        self.proxy_read()
        self.proxy_send()

        self.stub_send()

        pass

if __name__ == '__main__':

    # 객체를 생성하기 전에 nerv 라이브러리를 초기화 해야 합니다.
    py_nerv36_thread.initialize()
    nerv.connect_log_server("127.0.0.1", 5959);

    <xsl:value-of select="$component_name"/> = cNerv_Component_<xsl:value-of select="$component_name"/>()

    <xsl:value-of select="$component_name"/>.Start()

    try:
        a = 0
        # main loop
        while True:
            time.sleep(1)
            <xsl:value-of select="$component_name"/>.Update()

    # Ctrl + C를 입력할 경우
    except KeyboardInterrupt:
        print('[Ctrl + C] <xsl:value-of select="$component_name"/>를 중지합니다.')

    del <xsl:value-of select="$component_name"/>

    nerv.close_log_server();
    py_nerv36_thread.finalize()
    print('프로그램을 종료합니다.')

</xsl:template>
</xsl:stylesheet>
