<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:include href="../../../../../../xsl_util.xsl"/>

<xsl:output method="text" encoding="utf-8" omit-xml-declaration="yes" indent="no"/>
<xsl:param name = "export_data_domain_path" />
<xsl:param name = "export_data_name" />
<xsl:template match="/">
  <xsl:for-each select="nerv_icde/datadomain/row">
    <xsl:if test="path=$export_data_domain_path">
      <xsl:variable name="open_namespace_path">
        <xsl:call-template name="replace">
          <xsl:with-param name="text" select="path" />
          <xsl:with-param name="replace" select="'/'" />
          <xsl:with-param name="by" select="' { namespace '" />
        </xsl:call-template></xsl:variable>
      <xsl:variable name="close_namespace_path">
        <xsl:call-template name="replace">
          <xsl:with-param name="text" select="path" />
          <xsl:with-param name="replace" select="'/'" />
          <xsl:with-param name="by" select="' */ } /* '" />
        </xsl:call-template>
      </xsl:variable><xsl:text/>
#pragma once<xsl:text/>
/******************************************************************************
    domain   : <xsl:value-of select="name"/>
    domain creator   : <xsl:value-of select="author"/>
    domain create date : <xsl:value-of select="create-day"/>
    domain description : <xsl:value-of select="description"/>
      <xsl:for-each select="data/row">
        <xsl:if test="name=$export_data_name">
    data name : <xsl:value-of select="name"/>
    data writer   : <xsl:value-of select="../../author"/>
    data description: <xsl:value-of select="description"/>
*******************************************************************************/<xsl:text/>
          <xsl:if test="type='alias'">
            <xsl:variable name="real_domain_id" select="real_domain_id"/>
            <xsl:variable name="real_data" select="real_data"/>
            <xsl:for-each select="/nerv_icde/datadomain/row">
              <xsl:if test="id=$real_domain_id">
#include &lt;Nerv36/Data<xsl:value-of select="path"/>/<xsl:value-of select="$real_data"/>.hh&gt;<xsl:text/>
              </xsl:if>
            </xsl:for-each>
          </xsl:if>
          <xsl:if test="type='struct'">
            <xsl:for-each select="datafield/row">
              <xsl:variable name="real_domain_id" select="real_domain_id"/>
              <xsl:variable name="real_data" select="real_data"/>
              <xsl:if test="type='alias'">
                <xsl:for-each select="/nerv_icde/datadomain/row">
                  <xsl:if test="id=$real_domain_id">
#include &lt;Nerv36/Data<xsl:value-of select="path"/>/<xsl:value-of select="$real_data"/>.hh&gt;<xsl:text/>
                  </xsl:if>
                </xsl:for-each>
              </xsl:if>
            </xsl:for-each>
          </xsl:if>
#include &lt;Nerv36/Nerv.hh&gt;<xsl:text/>
#include &lt;stdio.h&gt;<xsl:text/>
#include &lt;string&gt;<xsl:text/>

namespace Nerv36 { namespace Data <xsl:value-of select="$open_namespace_path" /> {<xsl:text>
</xsl:text>
          <xsl:if test="type='scaled64_t' or type='scaled32_t' or type='scaled16_t' or type='scaled8_t' or type='u_scaled64_t' or type='u_scaled32_t' or type='u_scaled16_t' or type='u_scaled8_t'">
inline const double min_<xsl:value-of select="name"/>() { return double(<xsl:value-of select="scmin"/>); }
inline const double max_<xsl:value-of select="name"/>() { return double(<xsl:value-of select="scmax"/>); }
          </xsl:if>

          <xsl:choose>
            <xsl:when test="type='scaled64_t'">
typedef ::Nerv36::TReal&lt; ::Nerv36::Int64, min_<xsl:value-of select="name"/>, max_<xsl:value-of select="name"/> &gt; <xsl:value-of select="name"/>;
            </xsl:when>
            <xsl:when test="type='scaled32_t'">
typedef ::Nerv36::TReal&lt; ::Nerv36::Int32, min_<xsl:value-of select="name"/>, max_<xsl:value-of select="name"/> &gt; <xsl:value-of select="name"/>;
            </xsl:when>
            <xsl:when test="type='scaled16_t'">
typedef ::Nerv36::TReal&lt; ::Nerv36::Int16, min_<xsl:value-of select="name"/>, max_<xsl:value-of select="name"/> &gt; <xsl:value-of select="name"/>;
            </xsl:when>
            <xsl:when test="type='scaled8_t'">
typedef ::Nerv36::TReal&lt; ::Nerv36::Int8, min_<xsl:value-of select="name"/>, max_<xsl:value-of select="name"/> &gt; <xsl:value-of select="name"/>;
            </xsl:when>
            <xsl:when test="type='u_scaled64_t'">
typedef ::Nerv36::TReal&lt; ::Nerv36::uInt64, min_<xsl:value-of select="name"/>, max_<xsl:value-of select="name"/> &gt; <xsl:value-of select="name"/>;
            </xsl:when>
            <xsl:when test="type='u_scaled32_t'">
typedef ::Nerv36::TReal&lt; ::Nerv36::uInt32, min_<xsl:value-of select="name"/>, max_<xsl:value-of select="name"/> &gt; <xsl:value-of select="name"/>;
            </xsl:when>
            <xsl:when test="type='u_scaled16_t'">
typedef ::Nerv36::TReal&lt; ::Nerv36::uInt16, min_<xsl:value-of select="name"/>, max_<xsl:value-of select="name"/> &gt; <xsl:value-of select="name"/>;
            </xsl:when>
            <xsl:when test="type='u_scaled8_t'">
typedef ::Nerv36::TReal&lt; ::Nerv36::uInt8, min_<xsl:value-of select="name"/>, max_<xsl:value-of select="name"/> &gt; <xsl:value-of select="name"/>;
            </xsl:when>
            <xsl:when test="type='enum64_t'">
typedef ::Nerv36::Enum64 <xsl:value-of select="name"/>;
            </xsl:when>
            <xsl:when test="type='enum32_t'">
typedef ::Nerv36::Enum32 <xsl:value-of select="name"/>;
            </xsl:when>
            <xsl:when test="type='enum16_t'">
typedef ::Nerv36::Enum16 <xsl:value-of select="name"/>;
            </xsl:when>
            <xsl:when test="type='enum8_t'">
typedef ::Nerv36::Enum8 <xsl:value-of select="name"/>;
            </xsl:when>
            <xsl:when test="type='int64_t'">
typedef ::Nerv36::Int64 <xsl:value-of select="name"/>;
            </xsl:when>
            <xsl:when test="type='int32_t'">
typedef ::Nerv36::Int32 <xsl:value-of select="name"/>;
            </xsl:when>
            <xsl:when test="type='int16_t'">
typedef ::Nerv36::Int16 <xsl:value-of select="name"/>;
            </xsl:when>
            <xsl:when test="type='int8_t'">
typedef ::Nerv36::Int8 <xsl:value-of select="name"/>;
            </xsl:when>
            <xsl:when test="type='u_int64_t'">
typedef ::Nerv36::uInt64 <xsl:value-of select="name"/>;
            </xsl:when>
            <xsl:when test="type='u_int32_t'">
typedef ::Nerv36::uInt32 <xsl:value-of select="name"/>;
            </xsl:when>
            <xsl:when test="type='u_int16_t'">
typedef ::Nerv36::uInt16 <xsl:value-of select="name"/>;
            </xsl:when>
            <xsl:when test="type='u_int8_t'">
typedef ::Nerv36::uInt8 <xsl:value-of select="name"/>;
            </xsl:when>
            <xsl:when test="type='ieee754_32_t'">
typedef ::Nerv36::Float32 <xsl:value-of select="name"/>;
            </xsl:when>
            <xsl:when test="type='ieee754_64_t'">
typedef ::Nerv36::Float64 <xsl:value-of select="name"/>;
            </xsl:when>
            <xsl:when test="type='char_t'">
typedef ::Nerv36::Char8 <xsl:value-of select="name"/>;
            </xsl:when>
            <xsl:when test="type='wchar_t'">
typedef ::Nerv36::Char16 <xsl:value-of select="name"/>;
            </xsl:when>
            <xsl:when test="type='alias'">
              <xsl:variable name="real_data_domain_namespace">
                <xsl:call-template name="get_data_domain_namespace">
                  <xsl:with-param name="data_domain_id" select="real_domain_id" />
                </xsl:call-template>
              </xsl:variable>
typedef ::Nerv36::Data<xsl:value-of select="$real_data_domain_namespace"/>::<xsl:value-of select="real_data"/><xsl:text> </xsl:text><xsl:value-of select="name"/>;
            </xsl:when>
          </xsl:choose>
          <xsl:if test="type='enum64_t' or type='enum32_t' or type='enum16_t' or type='enum8_t'">
            <xsl:for-each select="datafield/row">
const <xsl:value-of select="../../name"/><xsl:text disable-output-escaping="yes"> </xsl:text><xsl:value-of select="member_name"/> = <xsl:value-of select="scmin"/>;
            </xsl:for-each>
          </xsl:if>
          <xsl:if test="type!='struct'">
typedef THistory_elem&lt;<xsl:value-of select="name"/>&gt; <xsl:value-of select="name"/>_history_elem;
typedef THistory&lt;<xsl:value-of select="name"/>&gt; <xsl:value-of select="name"/>_history;
          </xsl:if>
          <xsl:if test="type='struct'">
#pragma pack(1)
#pragma warning(disable: 4200)
struct __attribute__((packed)) <xsl:value-of select="name"/>
{<xsl:text/>
// private:
//     <xsl:value-of select="name"/>() {}
//     ~<xsl:value-of select="name"/>() {}

public:
    /* 가변 데이터 버퍼 */
    <!-- // 가변배열이 가변구조일 경우에는 __varray_offset이 음수로 정의된다.
    // 때문에 최대 패킷 크기 4G로 정의한 nerv에서는
    // __varray_offset을 64비트 정수로 정의한다. -->
    ::Nerv36::Int64 __varray_offset; //

    void init_dynamic_buffer(size_t _size)
    {

        ::Nerv36::Int8* p = (::Nerv36::Int8*)&amp;__varray_offset;

        ::Nerv36::Pksize* struct_offset_ = (::Nerv36::Pksize*)(p + sizeof(<xsl:value-of select="name"/>) + 0*sizeof(::Nerv36::Pksize));
        ::Nerv36::Pksize* dynamicmax_ = (::Nerv36::Pksize*)(p + sizeof(<xsl:value-of select="name"/>) + 1*sizeof(::Nerv36::Pksize));
        ::Nerv36::Pksize* dynamicsize_ = (::Nerv36::Pksize*)(p + sizeof(<xsl:value-of select="name"/>) + 2*sizeof(::Nerv36::Pksize));

        *struct_offset_ = sizeof(<xsl:value-of select="name"/>);
        *dynamicmax_ = (::Nerv36::Pksize)_size;
        *dynamicsize_ = 0;
        init_varray_offset( sizeof(<xsl:value-of select="name"/>) );
    }

    static <xsl:value-of select="name"/>* malloc(size_t _size = 65536)
    {
        // 할당크기는 구조체 기본크기 + 가변버퍼 할당 제어 64bit index + 가변버퍼총크기
        void* buf_ = ::malloc( sizeof(<xsl:value-of select="name"/>) + 3*sizeof(::Nerv36::Pksize) +  _size );
        <xsl:value-of select="name"/>* new_ = (<xsl:value-of select="name"/>*)buf_;

        new_->init_dynamic_buffer(_size);

        return new_;
    }
    <xsl:value-of select="name"/>* realloc(size_t _size = 0)
    {
        if( _size &lt;= dynamicmax() ) _size = dynamicmax()*2;
        void* buf_ = ::realloc( this, sizeof(<xsl:value-of select="name"/>) + 3*sizeof(::Nerv36::Pksize) +  _size );
        <xsl:value-of select="name"/>* new_ = (<xsl:value-of select="name"/>*)buf_;
        new_->dynamicmax() = (Pksize)_size;
        return new_;
    }

    void free() {
        ::free(this);
    }

    ::Nerv36::Pksize fit_size() const { return sizeof(<xsl:value-of select="name"/>) + 3*sizeof(::Nerv36::Pksize) + dynamicsize(); }

    void* memory()
    {
        return (void*)((uint8_t*)this + __varray_offset - struct_offset() );
    }

    const Pksize&amp; struct_offset() const
    {
        return *(Pksize*)((uint8_t*)this + __varray_offset);
    }

    Pksize&amp; struct_offset()
    {
        return *(Pksize*)((uint8_t*)this + __varray_offset);
    }

    Pksize&amp; dynamicmax()
    {
        return *(Pksize*)((uint8_t*)this + __varray_offset + sizeof(::Nerv36::Pksize));
    }
    const Pksize&amp; dynamicmax() const
    {
        return *(Pksize*)((uint8_t*)this + __varray_offset + sizeof(::Nerv36::Pksize));
    }
    Pksize&amp; dynamicsize()
    {
        return *(Pksize*)((uint8_t*)this + __varray_offset + 2*sizeof(::Nerv36::Pksize));
    }
    const Pksize&amp; dynamicsize() const
    {
        return *(Pksize*)((uint8_t*)this + __varray_offset + 2*sizeof(::Nerv36::Pksize));
    }
    ::Nerv36::uInt8* dynamicbuffer()
    {
        return ((uint8_t*)this + __varray_offset + 3*sizeof(Pksize));
    }
    const ::Nerv36::uInt8* dynamicbuffer() const
    {
        return ((const uint8_t*)this + __varray_offset + 3*sizeof(Pksize));
    }
    void init_varray_offset(::Nerv36::Int64 _varray_offset)
    {
        __varray_offset = _varray_offset;

        <!-- // Narray 나 Fix 의 경우 init_dynamic_buffer를 모두 수행해준다.
        // 내부에 가변버퍼를 가지는 멤버가 있을수 있기 때문이다. -->
            <xsl:for-each select="datafield/row[type='alias']">
              <xsl:variable name="original_type">
                <xsl:if test="type='alias'">
                  <xsl:call-template name="get_original_type">
                    <xsl:with-param name="data_domain_id" select="real_domain_id" />
                    <xsl:with-param name="data" select="real_data" />
                  </xsl:call-template>
                </xsl:if>
                <xsl:if test="type!='alias'">
                  <xsl:value-of select="type"/>
                </xsl:if>
              </xsl:variable>
              <xsl:if test="$original_type='struct'">
                <xsl:if test="arraytype='NO'">
        {
            ::Nerv36::Int64 member_varray_offset = __varray_offset;
            member_varray_offset -= (::Nerv36::Int64)( (uint8_t*)&amp;<xsl:value-of select="member_name"/> - (uint8_t*)this );
            <xsl:value-of select="member_name"/>.init_varray_offset( member_varray_offset );
        }
                </xsl:if>
                <xsl:if test="arraytype='FIX'">
        {
            for(int i=0;i&lt;<xsl:value-of select="arraysize"/>;i++) {
                ::Nerv36::Int64 member_varray_offset = __varray_offset;
                member_varray_offset -= (::Nerv36::Int64)( (uint8_t*)(<xsl:value-of select="member_name"/>+i) - (uint8_t*)this );
                <xsl:value-of select="member_name"/>[i].init_varray_offset( member_varray_offset );
            }
        }
                </xsl:if>
              </xsl:if>
            </xsl:for-each>
    }

            <xsl:for-each select="datafield/row">
              <xsl:variable name="description_aligned">
                <xsl:call-template name="replace">
                  <xsl:with-param name="text" select="description" />
                  <xsl:with-param name="replace" select="'&#10;'" />
                  <xsl:with-param name="by" select="'&#10;    // '" />
                </xsl:call-template>
              </xsl:variable>
              <xsl:variable name="real_data_domain_namespace">
                <xsl:call-template name="get_data_domain_namespace">
                  <xsl:with-param name="data_domain_id" select="real_domain_id" />
                </xsl:call-template>
              </xsl:variable>
              <xsl:variable name="member_type">
                <xsl:choose>
                  <xsl:when test="type='u_scaled64_t'">::Nerv36::TReal&lt; ::Nerv36::uInt64, min_<xsl:value-of select="member_name"/>, max_<xsl:value-of select="member_name"/> &gt;</xsl:when>
                  <xsl:when test="type='u_scaled32_t'">::Nerv36::TReal&lt; ::Nerv36::uInt32, min_<xsl:value-of select="member_name"/>, max_<xsl:value-of select="member_name"/> &gt;</xsl:when>
                  <xsl:when test="type='u_scaled16_t'">::Nerv36::TReal&lt; ::Nerv36::uInt16, min_<xsl:value-of select="member_name"/>, max_<xsl:value-of select="member_name"/> &gt;</xsl:when>
                  <xsl:when test="type='u_scaled8_t'">::Nerv36::TReal&lt; ::Nerv36::uInt8, min_<xsl:value-of select="member_name"/>, max_<xsl:value-of select="member_name"/> &gt;</xsl:when>
                  <xsl:when test="type='scaled64_t'">::Nerv36::TReal&lt; ::Nerv36::Int64, min_<xsl:value-of select="member_name"/>, max_<xsl:value-of select="member_name"/> &gt;</xsl:when>
                  <xsl:when test="type='scaled32_t'">::Nerv36::TReal&lt; ::Nerv36::Int32, min_<xsl:value-of select="member_name"/>, max_<xsl:value-of select="member_name"/> &gt;</xsl:when>
                  <xsl:when test="type='scaled16_t'">::Nerv36::TReal&lt; ::Nerv36::Int16, min_<xsl:value-of select="member_name"/>, max_<xsl:value-of select="member_name"/> &gt;</xsl:when>
                  <xsl:when test="type='scaled8_t'">::Nerv36::TReal&lt; ::Nerv36::Int8, min_<xsl:value-of select="member_name"/>, max_<xsl:value-of select="member_name"/> &gt;</xsl:when>
                  <xsl:when test="type='alias'">::Nerv36::Data<xsl:value-of select="$real_data_domain_namespace"/>::<xsl:value-of select="real_data"/></xsl:when>
                  <xsl:when test="type='int8_t'">::Nerv36::Int8</xsl:when>
                  <xsl:when test="type='int16_t'">::Nerv36::Int16</xsl:when>
                  <xsl:when test="type='int32_t'">::Nerv36::Int32</xsl:when>
                  <xsl:when test="type='int64_t'">::Nerv36::Int64</xsl:when>
                  <xsl:when test="type='u_int8_t'">::Nerv36::uInt8</xsl:when>
                  <xsl:when test="type='u_int16_t'">::Nerv36::uInt16</xsl:when>
                  <xsl:when test="type='u_int32_t'">::Nerv36::uInt32</xsl:when>
                  <xsl:when test="type='u_int64_t'">::Nerv36::uInt64</xsl:when>
                  <xsl:when test="type='ieee754_32_t'">::Nerv36::Float32</xsl:when>
                  <xsl:when test="type='ieee754_64_t'">::Nerv36::Float64</xsl:when>
                  <xsl:when test="type='char_t'">::Nerv36::Char8</xsl:when>
                  <xsl:when test="type='wchar_t'">::Nerv36::Char16</xsl:when>
                  <xsl:otherwise>::Nerv36::<xsl:value-of select="type"/></xsl:otherwise>
                </xsl:choose>
              </xsl:variable>
<xsl:text>
    </xsl:text>// <xsl:value-of select="$description_aligned"/><xsl:text/>
              <xsl:if test="type='scaled64_t' or type='scaled32_t' or type='scaled16_t' or type='scaled8_t' or type='u_scaled64_t' or type='u_scaled32_t' or type='u_scaled16_t' or type='u_scaled8_t'">
<xsl:text>
    </xsl:text>inline static const double min_<xsl:value-of select="member_name"/>() { return double(<xsl:value-of select="scmin"/>); }<xsl:text/>
    inline static const double max_<xsl:value-of select="member_name"/>() { return double(<xsl:value-of select="scmax"/>); }<xsl:text/>
              </xsl:if>
              <xsl:if test="arraytype='NO'">
<xsl:text>
    </xsl:text><xsl:value-of select="$member_type"/><xsl:text> </xsl:text><xsl:value-of select="member_name"/><xsl:if test="not(bitsize = '0')"> :<xsl:value-of select="bitsize"/></xsl:if>;<xsl:text/>
                <xsl:if test="(type='alias') and (bitsize = '0')">
<xsl:text>
    </xsl:text><xsl:value-of select="$member_type"/><xsl:text>&amp; </xsl:text><xsl:value-of select="member_name"/>_ref() { return <xsl:value-of select="member_name"/>; }<xsl:text/>
                </xsl:if>
              </xsl:if>
              <xsl:if test="arraytype='FIX'">
<xsl:text>
    </xsl:text><xsl:value-of select="$member_type"/><xsl:text> </xsl:text><xsl:value-of select="member_name"/>[<xsl:if test="arraysize='0'">1</xsl:if><xsl:if test="arraysize!='0'"><xsl:value-of select="arraysize"/></xsl:if>];<xsl:text/>
                <xsl:choose>
                  <xsl:when test="type='scaled64_t' or type='scaled32_t' or type='scaled16_t' or type='scaled8_t' or type='u_scaled64_t' or type='u_scaled32_t' or type='u_scaled16_t' or type='u_scaled8_t'">
<xsl:text>
    </xsl:text>inline double <xsl:value-of select="member_name"/>_get_at(size_t _index) { return (double)<xsl:value-of select="member_name"/>[_index]; }<xsl:text/>
<xsl:text>
    </xsl:text>inline void <xsl:value-of select="member_name"/>_set_at(size_t _index, double _val) { <xsl:value-of select="member_name"/>[_index] = _val; }<xsl:text/>
                  </xsl:when>
                  <xsl:when test="type='alias'">
          <xsl:value-of select="$member_type"/>&amp;<xsl:text> </xsl:text><xsl:value-of select="member_name"/>_at(size_t _index=0) { return <xsl:value-of select="member_name"/>[_index]; }<xsl:text/>
                  </xsl:when>
                  <xsl:otherwise>
<xsl:text>
    </xsl:text>inline <xsl:value-of select="$member_type"/><xsl:text> </xsl:text><xsl:value-of select="member_name"/>_get_at(size_t _index) { return <xsl:value-of select="member_name"/>[_index]; }<xsl:text/>
<xsl:text>
    </xsl:text>inline void <xsl:value-of select="member_name"/>_set_at(size_t _index, <xsl:value-of select="$member_type"/> _val) { <xsl:value-of select="member_name"/>[_index] = _val; }<xsl:text/>
                  </xsl:otherwise>
                </xsl:choose>
<xsl:text>
    </xsl:text>inline int <xsl:value-of select="member_name"/>_maxsize() { return <xsl:value-of select="arraysize"/>; }<xsl:text/>
              </xsl:if>
              <xsl:if test="arraytype='VARIABLE'">
<xsl:text>
    </xsl:text>Variable_array_field_dctrl <xsl:value-of select="member_name"/>_dctrl;<xsl:text/>
                <xsl:choose>
                  <xsl:when test="type='scaled64_t' or type='scaled32_t' or type='scaled16_t' or type='scaled8_t' or type='u_scaled64_t' or type='u_scaled32_t' or type='u_scaled16_t' or type='u_scaled8_t'">
<xsl:text>
    </xsl:text>inline double <xsl:value-of select="member_name"/>_get_at(size_t _index) { return (double)((<xsl:value-of select="$member_type"/>*)(dynamicbuffer()+<xsl:value-of select="member_name"/>_dctrl.dindex))[_index]; }<xsl:text/>
<xsl:text>
    </xsl:text>inline void <xsl:value-of select="member_name"/>_set_at(size_t _index, double _val) { ((<xsl:value-of select="$member_type"/>*)(dynamicbuffer()+<xsl:value-of select="member_name"/>_dctrl.dindex))[_index] = _val; }<xsl:text/>
                  </xsl:when>
                  <xsl:when test="type='alias'">
<xsl:text>
    </xsl:text><xsl:value-of select="$member_type"/>&amp; <xsl:value-of select="member_name"/>_at(size_t _index=0) { return ((<xsl:value-of select="$member_type"/>*)(dynamicbuffer()+<xsl:value-of select="member_name"/>_dctrl.dindex))[_index]; }<xsl:text/>
                  </xsl:when>
                  <xsl:otherwise>
<xsl:text>
    </xsl:text>inline <xsl:value-of select="$member_type"/><xsl:text> </xsl:text><xsl:value-of select="member_name"/>_get_at(size_t _index) { return ((<xsl:value-of select="$member_type"/>*)(dynamicbuffer()+<xsl:value-of select="member_name"/>_dctrl.dindex))[_index]; }<xsl:text/>
<xsl:text>
    </xsl:text>inline void <xsl:value-of select="member_name"/>_set_at(size_t _index, <xsl:value-of select="$member_type"/> _val) { ((<xsl:value-of select="$member_type"/>*)(dynamicbuffer()+<xsl:value-of select="member_name"/>_dctrl.dindex))[_index] = _val; }<xsl:text/>
                  </xsl:otherwise>
                </xsl:choose>
<xsl:text>
    </xsl:text>inline int <xsl:value-of select="member_name"/>_maxsize() { return <xsl:value-of select="arraysize"/>; }<xsl:text/>
<xsl:text>
    </xsl:text><xsl:value-of select="$member_type"/>* <xsl:value-of select="member_name"/>() { return (<xsl:value-of select="$member_type"/>*)(dynamicbuffer()+<xsl:value-of select="member_name"/>_dctrl.dindex); }<xsl:text/>
<xsl:text>
    </xsl:text><xsl:value-of select="$member_type"/> const* <xsl:value-of select="member_name"/>() const { return (<xsl:value-of select="$member_type"/> const*)(dynamicbuffer()+<xsl:value-of select="member_name"/>_dctrl.dindex); }<xsl:text/>
<xsl:text>
    </xsl:text>size_t <xsl:value-of select="member_name"/>_alloc(size_t _size)
    {
        size_t need_dynamics_size;
        const Pksize&amp; dynamicmax_ = dynamicmax();
        Pksize&amp; dynamicsize_ = dynamicsize();
        <xsl:value-of select="member_name"/>_dctrl.dindex = dynamicsize_;
        size_t byte_size = _size*sizeof(<xsl:value-of select="$member_type"/>);

        if(dynamicmax_ &lt; dynamicsize_ + byte_size) {
            need_dynamics_size = dynamicsize_ + byte_size;
        }
        else {
            <xsl:value-of select="member_name"/>_dctrl.dsize = (Pksize)byte_size;
            dynamicsize_ += <xsl:value-of select="member_name"/>_dctrl.dsize;
            <xsl:if test="type='alias'">
            <xsl:value-of select="$member_type"/>* member_ = <xsl:value-of select="member_name"/>();
            for(int i=0;i&lt;_size;i++) {
                ::Nerv36::Int64 member_varray_offset = __varray_offset;
                member_varray_offset -= (::Nerv36::Int64)( (uint8_t*)(member_+i) - (uint8_t*)this );
                member_[i].init_varray_offset( member_varray_offset );
            }
            </xsl:if>
            need_dynamics_size=0;
        }
        return need_dynamics_size;
    }<xsl:text/>
<xsl:text>
    </xsl:text>int <xsl:value-of select="member_name"/>_size() const
    {
        return <xsl:value-of select="member_name"/>_dctrl.dsize / sizeof(<xsl:value-of select="$member_type"/>);
    }
              </xsl:if>
<xsl:text>
</xsl:text>
            </xsl:for-each>

    void set(int _val)
    {
            <xsl:if test="type='struct'">
              <xsl:for-each select="datafield/row">
                <xsl:variable name="real_data_domain_namespace">
                  <xsl:call-template name="get_data_domain_namespace">
                    <xsl:with-param name="data_domain_id" select="real_domain_id" />
                  </xsl:call-template>
                </xsl:variable>
                <xsl:variable name="member_type">
                  <xsl:choose>
                    <xsl:when test="type='u_scaled64_t'">::Nerv36::TReal&lt; ::Nerv36::uInt64, min_<xsl:value-of select="member_name"/>, max_<xsl:value-of select="member_name"/> &gt;</xsl:when>
                    <xsl:when test="type='u_scaled32_t'">::Nerv36::TReal&lt; ::Nerv36::uInt32, min_<xsl:value-of select="member_name"/>, max_<xsl:value-of select="member_name"/> &gt;</xsl:when>
                    <xsl:when test="type='u_scaled16_t'">::Nerv36::TReal&lt; ::Nerv36::uInt16, min_<xsl:value-of select="member_name"/>, max_<xsl:value-of select="member_name"/> &gt;</xsl:when>
                    <xsl:when test="type='u_scaled8_t'">::Nerv36::TReal&lt; ::Nerv36::uInt8, min_<xsl:value-of select="member_name"/>, max_<xsl:value-of select="member_name"/> &gt;</xsl:when>
                    <xsl:when test="type='scaled64_t'">::Nerv36::TReal&lt; ::Nerv36::Int64, min_<xsl:value-of select="member_name"/>, max_<xsl:value-of select="member_name"/> &gt;</xsl:when>
                    <xsl:when test="type='scaled32_t'">::Nerv36::TReal&lt; ::Nerv36::Int32, min_<xsl:value-of select="member_name"/>, max_<xsl:value-of select="member_name"/> &gt;</xsl:when>
                    <xsl:when test="type='scaled16_t'">::Nerv36::TReal&lt; ::Nerv36::Int16, min_<xsl:value-of select="member_name"/>, max_<xsl:value-of select="member_name"/> &gt;</xsl:when>
                    <xsl:when test="type='scaled8_t'">::Nerv36::TReal&lt; ::Nerv36::Int8, min_<xsl:value-of select="member_name"/>, max_<xsl:value-of select="member_name"/> &gt;</xsl:when>
                    <xsl:when test="type='alias'">::Nerv36::Data<xsl:value-of select="$real_data_domain_namespace"/>::<xsl:value-of select="real_data"/></xsl:when>
                    <xsl:when test="type='int8_t'">::Nerv36::Int8</xsl:when>
                    <xsl:when test="type='int16_t'">::Nerv36::Int16</xsl:when>
                    <xsl:when test="type='int32_t'">::Nerv36::Int32</xsl:when>
                    <xsl:when test="type='int64_t'">::Nerv36::Int64</xsl:when>
                    <xsl:when test="type='u_int8_t'">::Nerv36::uInt8</xsl:when>
                    <xsl:when test="type='u_int16_t'">::Nerv36::uInt16</xsl:when>
                    <xsl:when test="type='u_int32_t'">::Nerv36::uInt32</xsl:when>
                    <xsl:when test="type='u_int64_t'">::Nerv36::uInt64</xsl:when>
                    <xsl:when test="type='ieee754_32_t'">::Nerv36::Float32</xsl:when>
                    <xsl:when test="type='ieee754_64_t'">::Nerv36::Float64</xsl:when>
                    <xsl:when test="type='char_t'">::Nerv36::Char8</xsl:when>
                    <xsl:when test="type='wchar_t'">::Nerv36::Char16</xsl:when>
                    <xsl:otherwise>::Nerv36::<xsl:value-of select="type"/></xsl:otherwise>
                  </xsl:choose>
                </xsl:variable>
                <xsl:variable name="original_type">
                  <xsl:if test="type='alias'">
                    <xsl:call-template name="get_original_type">
                      <xsl:with-param name="data_domain_id" select="real_domain_id" />
                      <xsl:with-param name="data" select="real_data" />
                    </xsl:call-template>
                  </xsl:if>
                  <xsl:if test="type!='alias'">
                    <xsl:value-of select="type"/>
                  </xsl:if>
                </xsl:variable>
                <xsl:choose>
                  <xsl:when test="arraytype='NO'">
                    <xsl:choose>
                      <xsl:when test="$original_type='struct'">
<xsl:text>
        </xsl:text><xsl:value-of select="member_name" />.set(_val);<xsl:text/>
                      </xsl:when>
                      <xsl:when test="$original_type='scaled8_t' or $original_type='scaled16_t' or $original_type='scaled32_t' or $original_type='scaled64_t' or $original_type='u_scaled8_t' or $original_type='u_scaled16_t' or $original_type='u_scaled32_t' or $original_type='u_scaled64_t'">
<xsl:text>
        </xsl:text><xsl:value-of select="member_name" /> = (double)_val;<xsl:text/>
                      </xsl:when>
                      <xsl:otherwise>
<xsl:text>
        </xsl:text><xsl:value-of select="member_name" /> = (<xsl:value-of select="$member_type" />)_val;<xsl:text/>
                      </xsl:otherwise>
                    </xsl:choose>
                  </xsl:when>
                  <xsl:when test="arraytype='FIX'">
                    <xsl:choose>
                      <xsl:when test="$original_type='struct'">
<xsl:text>
        </xsl:text><xsl:value-of select="member_name" />[0].set(_val);<xsl:text/>
                      </xsl:when>
                      <xsl:when test="original_type='scaled8_t' or original_type='scaled16_t' or original_type='scaled32_t' or original_type='scaled64_t' or original_type='u_scaled8_t' or original_type='u_scaled16_t' or original_type='u_scaled32_t' or original_type='u_scaled64_t'">
<xsl:text>
        </xsl:text><xsl:value-of select="member_name" />[0] = (double)_val;<xsl:text/>
                      </xsl:when>
                      <xsl:otherwise>
<xsl:text>
        </xsl:text><xsl:value-of select="member_name" />[0] = (<xsl:value-of select="$member_type" />)_val;<xsl:text/>
                      </xsl:otherwise>
                    </xsl:choose>
                  </xsl:when>
                  <xsl:when test="arraytype='VARIABLE'">
<xsl:text>
        </xsl:text><xsl:value-of select="member_name" />_alloc(<xsl:value-of select="member_name" />_maxsize());<xsl:text/>
                    <xsl:choose>
                      <xsl:when test="type='alias'">
<xsl:text>
        </xsl:text><xsl:value-of select="member_name" />()[0].set(_val);<xsl:text/>
                      </xsl:when>
                      <xsl:when test="original_type='scaled8_t' or original_type='scaled16_t' or original_type='scaled32_t' or original_type='scaled64_t' or original_type='u_scaled8_t' or original_type='u_scaled16_t' or original_type='u_scaled32_t' or original_type='u_scaled64_t'">
<xsl:text>
        </xsl:text><xsl:value-of select="member_name" />()[0] = (double)_val;<xsl:text/>
                      </xsl:when>
                      <xsl:otherwise>
<xsl:text>
        </xsl:text><xsl:value-of select="member_name" />()[0] = (<xsl:value-of select="$member_type" />)_val;<xsl:text/>
                      </xsl:otherwise>
                    </xsl:choose>
                  </xsl:when>
                </xsl:choose>
              </xsl:for-each>
            </xsl:if>
    }

    void print(std::string _var)
    {
            <xsl:if test="type='struct'">
        printf( "sizeof(%s)=%d\n" , _var.c_str(), (int)sizeof(*this));<xsl:text/>
        printf( "%s.fit_size()=%d\n" , _var.c_str(), (int)fit_size());<xsl:text/>
              <xsl:for-each select="datafield/row">
                <xsl:variable name="original_type">
                  <xsl:if test="type='alias'">
                    <xsl:call-template name="get_original_type">
                      <xsl:with-param name="data_domain_id" select="real_domain_id" />
                      <xsl:with-param name="data" select="real_data" />
                    </xsl:call-template>
                  </xsl:if>
                  <xsl:if test="type!='alias'">
                    <xsl:value-of select="type"/>
                  </xsl:if>
                </xsl:variable>
                <xsl:choose>
                  <xsl:when test="arraytype='NO'">
                    <xsl:choose>
                      <xsl:when test="$original_type='struct'">
<xsl:text>
        </xsl:text><xsl:value-of select="member_name" />.print(_var+".<xsl:value-of select="member_name" />");<xsl:text/>
                      </xsl:when>
                      <xsl:when test="type='scaled8_t' or type='scaled16_t' or type='scaled32_t' or type='scaled64_t' or type='u_scaled8_t' or type='u_scaled16_t' or type='u_scaled32_t' or type='u_scaled64_t'">
        printf( "%s.<xsl:value-of select="member_name"/>= %lf\n" , _var.c_str(), (double)<xsl:value-of select="member_name" />);<xsl:text/>
                      </xsl:when>
                      <xsl:otherwise>
        printf( "%s.<xsl:value-of select="member_name"/>= %d\n" , _var.c_str(), (int)<xsl:value-of select="member_name" />);<xsl:text/>
                      </xsl:otherwise>
                    </xsl:choose>
                  </xsl:when>
                  <xsl:when test="arraytype='FIX'">
                    <xsl:choose>
                      <xsl:when test="$original_type='struct'">
<xsl:text>
        </xsl:text><xsl:value-of select="member_name" />[0].print(_var+".<xsl:value-of select="member_name" />[0]");<xsl:text/>
                      </xsl:when>
                      <xsl:when test="type='scaled8_t' or type='scaled16_t' or type='scaled32_t' or type='scaled64_t' or type='u_scaled8_t' or type='u_scaled16_t' or type='u_scaled32_t' or type='u_scaled64_t'">
        printf( "%s.<xsl:value-of select="member_name"/>[0] = %lf\n" , _var.c_str(), (double)<xsl:value-of select="member_name" />[0]);<xsl:text/>
                      </xsl:when>
                      <xsl:otherwise>
        printf( "%s.<xsl:value-of select="member_name"/>[0] = %d\n" , _var.c_str(), (int)<xsl:value-of select="member_name" />[0]);<xsl:text/>
                      </xsl:otherwise>
                    </xsl:choose>
                  </xsl:when>
                  <xsl:when test="arraytype='VARIABLE'">
                    <xsl:choose>
                      <xsl:when test="type='alias'">
<xsl:text>
        </xsl:text><xsl:value-of select="member_name" />()[0].print(_var+".<xsl:value-of select="member_name" />[0]");<xsl:text/>
                      </xsl:when>
                      <xsl:when test="type='scaled8_t' or type='scaled16_t' or type='scaled32_t' or type='scaled64_t' or type='u_scaled8_t' or type='u_scaled16_t' or type='u_scaled32_t' or type='u_scaled64_t'">
        printf( "%s.<xsl:value-of select="member_name"/>[0] = %lf\n" , _var.c_str(), (double)<xsl:value-of select="member_name" />()[0]);<xsl:text/>
                      </xsl:when>
                      <xsl:otherwise>
        printf( "%s.<xsl:value-of select="member_name"/>[0] =%d\n" , _var.c_str(), (int)<xsl:value-of select="member_name" />()[0]);<xsl:text/>
                      </xsl:otherwise>
                    </xsl:choose>
                  </xsl:when>
                </xsl:choose>
              </xsl:for-each>
            </xsl:if>
    }


};
#pragma warning(default : 4200)
#pragma pack()
typedef THistory_elem&lt;<xsl:value-of select="name"/>&gt; <xsl:value-of select="name"/>_history_elem;
typedef THistory&lt;<xsl:value-of select="name"/>&gt; <xsl:value-of select="name"/>_history;

          </xsl:if>
} } /* <xsl:value-of select="$close_namespace_path" /> */
        </xsl:if>
      </xsl:for-each>
    </xsl:if>
  </xsl:for-each>
</xsl:template>


</xsl:stylesheet>
