<?xml version="1.0" encoding="UTF-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="text" encoding="utf-8" indent="yes"/>

<xsl:include href="../../../../../../xsl_util.xsl"/>
<xsl:include href="method_domain_template_call.xsl"/>
<xsl:include href="method_domain_template_callback.xsl"/>
<xsl:include href="method_domain_template_command.xsl"/>
<xsl:include href="method_domain_template_datagram.xsl"/>
<xsl:include href="method_domain_template_event.xsl"/>
<xsl:include href="method_domain_template_information.xsl"/>
<xsl:include href="method_domain_template_signal.xsl"/>
<xsl:include href="method_domain_template_signalback.xsl"/>

<xsl:param name = "export_method_domain_path" />
<xsl:param name = "export_method_name" />
<xsl:template match="/">
  <xsl:for-each select="nerv_icde/methoddomain/row">
    <xsl:if test="path=$export_method_domain_path">
      <xsl:variable name="open_namespace_path">
        <xsl:call-template name="replace">
          <xsl:with-param name="text" select="path" />
          <xsl:with-param name="replace" select="'/'" />
          <xsl:with-param name="by" select="' { namespace '" />
        </xsl:call-template></xsl:variable>
      <xsl:variable name="close_namespace_path">
        <xsl:call-template name="replace">
          <xsl:with-param name="text" select="path" />
          <xsl:with-param name="replace" select="'/'" />
          <xsl:with-param name="by" select="' */ } /* '" />
        </xsl:call-template>
      </xsl:variable>
#pragma once
/*******************************************************************************
    Document Header
    domain   : <xsl:value-of select="name"/>
    creator  : <xsl:value-of select="author"/>
    create date : <xsl:value-of select="create-day"/>
    description : <xsl:value-of select="description"/>
*******************************************************************************/
      <xsl:for-each select="method/row">
        <xsl:if test="name=$export_method_name">
          <xsl:variable name="in_data_domain_namespace">
          <xsl:call-template name="get_data_domain_namespace">
            <xsl:with-param name="data_domain_id" select="in_data_domain_id" />
          </xsl:call-template>
          </xsl:variable>
          <xsl:variable name="out_data_domain_namespace">
          <xsl:call-template name="get_data_domain_namespace">
            <xsl:with-param name="data_domain_id" select="out_data_domain_id" />
          </xsl:call-template>
          </xsl:variable>
          <xsl:variable name="in_data_domain_path">
          <xsl:call-template name="get_data_domain_path">
            <xsl:with-param name="data_domain_id" select="in_data_domain_id" />
          </xsl:call-template>
          </xsl:variable>
          <xsl:variable name="out_data_domain_path">
          <xsl:call-template name="get_data_domain_path">
            <xsl:with-param name="data_domain_id" select="out_data_domain_id" />
          </xsl:call-template>
          </xsl:variable>
/*******************************************************************************
    Method       : <xsl:value-of select="name"/>
    Input        : <xsl:if test="in_data != '(null)'"><xsl:value-of select="$in_data_domain_namespace"/>::<xsl:value-of select="in_data"/></xsl:if>
    output       : <xsl:if test="out_data != '(null)'"><xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/></xsl:if>
    Method Type  : <xsl:value-of select="type"/>
    Code         : <xsl:value-of select="code"/>
    Writer       : <xsl:value-of select="../../author"/>
    Description  : <xsl:value-of select="../../description"/>
*******************************************************************************/

#include &lt;Nerv36/Nerv.hh&gt;
<xsl:if test="in_data != '(null)'">
#include &lt;Nerv36/Data<xsl:value-of select="$in_data_domain_path"/>/<xsl:value-of select="in_data"/>.hh&gt;
</xsl:if>
<xsl:if test="out_data != '(null)'">
#include &lt;Nerv36/Data<xsl:value-of select="$out_data_domain_path"/>/<xsl:value-of select="out_data"/>.hh&gt;
</xsl:if>
namespace Nerv36 { namespace Method <xsl:value-of select="$open_namespace_path" /> {

          <xsl:if test="type='CALL'" ><xsl:call-template name="template_call" /></xsl:if>
          <xsl:if test="type='COMMAND'" ><xsl:call-template name="template_command" /></xsl:if>
          <xsl:if test="type='BROADCAST'" ><xsl:call-template name="template_datagram" /></xsl:if>
          <xsl:if test="type='INFORMATION'" ><xsl:call-template name="template_information" /></xsl:if>
          <xsl:if test="type='EVENT'" ><xsl:call-template name="template_event" /></xsl:if>
          <xsl:if test="type='SIGNAL'" ><xsl:call-template name="template_signal" /></xsl:if>
          <xsl:if test="type='CALLBACK'" ><xsl:call-template name="template_callback" /></xsl:if>
          <xsl:if test="type='SIGNALBACK'" ><xsl:call-template name="template_signalback" /></xsl:if>

} } /* <xsl:value-of select="$close_namespace_path" /> */

        </xsl:if>
      </xsl:for-each>
    </xsl:if>
  </xsl:for-each>
</xsl:template>


</xsl:stylesheet>
