<?xml version="1.0" encoding="UTF-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<!-- author: lee_yongwoo@waregram.com -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="text" encoding="utf-8" indent="yes"/>



<xsl:template name ="template_information" >
  <xsl:variable name="in_data_domain_namespace">
    <xsl:call-template name="get_data_domain_namespace">
      <xsl:with-param name="data_domain_id" select="in_data_domain_id" />
    </xsl:call-template>
  </xsl:variable>
  <xsl:variable name="out_data_domain_namespace">
    <xsl:call-template name="get_data_domain_namespace">
      <xsl:with-param name="data_domain_id" select="out_data_domain_id" />
    </xsl:call-template>
  </xsl:variable>
// proxy
struct Proxy_method_<xsl:value-of select="name"/>_ {

    virtual void on_<xsl:value-of select="name"/>_link(
        Msg_num     _msg_num,
        Error       _err,
        double _elapsed) = 0; //{}

    virtual void on_<xsl:value-of select="name"/>_unlink(Error _err) = 0;

    virtual void on_<xsl:value-of select="name"/>_sync(
        Sync_model  _sync_model,
        double      _elapsed,
        double      _limit<xsl:if test="out_data!='(null)'">,
        const Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>* _inf_dat_</xsl:if>) = 0;
};

class Proxy_method_<xsl:value-of select="name"/> : public Proxy_information {
    Proxy_method_<xsl:value-of select="name"/>_* interface_;

    virtual void on_link(Msg_num _msg_num, Error _err, double _elapsed)
    {
        interface_-&gt;on_<xsl:value-of select="name"/>_link(_msg_num, _err, _elapsed);
    }

    virtual void on_unlink( Error _err)
    {
        interface_-&gt;on_<xsl:value-of select="name"/>_unlink(_err);
    }

    virtual void on_sync(   Sync_model      _sync_model,
                            double          _elapsed,
                            double          _limit,
                            const void*     _inf_dat_,
                            Pksize          _size)
    {
        interface_-&gt;on_<xsl:value-of select="name"/>_sync(_sync_model, _elapsed, _limit<xsl:if test="out_data!='(null)'">, (const Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>*)_inf_dat_</xsl:if>);
    }

public:
    Proxy_method_<xsl:value-of select="name"/>(
        const Proxy&amp; _proxy_,
        Proxy_method_<xsl:value-of select="name"/>_* _interface_)
        : Proxy(_proxy_)
        , Proxy_information(<xsl:value-of select="code"/>, _proxy_)
        , interface_(_interface_)
    {
    }

    ~Proxy_method_<xsl:value-of select="name"/>()
    {
    }

    Error link(bool _reliability, double _limit, double* _elapsed_ = 0)
    {
        Promise* promise_;
        promise_ = Proxy_information::async_link(_reliability, _limit);
        Error err = Proxy_information::await_link_return(promise_, _elapsed_);
        return err;
    }

  <xsl:if test="out_data!='(null)'">
    Error read( Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>* _data_)
    {
        Error err;
        Nerv36::Pksize size;
        size = sizeof(Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>);
        err = Proxy_information::read(_data_, &amp;size );
        return err;
    }
  </xsl:if>
};


// stub
struct Stub_method_<xsl:value-of select="name"/>_ {
    virtual Error on_<xsl:value-of select="name"/>_link(Address _proxy_addr,
                                        bool        _reliability,
                                        double      _elapsed,
                                        double      _limit ) = 0;
    virtual void on_<xsl:value-of select="name"/>_unlink( Address _proxy_addr, Error _err) = 0;
};

class Stub_method_<xsl:value-of select="name"/> : public Stub_information {
    Stub_method_<xsl:value-of select="name"/>_* interface_;

    virtual Error on_link( Address _proxy_addr,
                                bool        _reliability,
                                double      _elapsed,
                                double      _limit )
    {
        return interface_-&gt;on_<xsl:value-of select="name"/>_link( _proxy_addr, _reliability, _elapsed, _limit );
    }

    virtual void on_unlink( Address _proxy_addr, Error _err)
    {
        interface_-&gt;on_<xsl:value-of select="name"/>_unlink(_proxy_addr, _err);
    }

public:
    Stub_method_<xsl:value-of select="name"/>(
        const Stub&amp; _stub_,
        Stub_method_<xsl:value-of select="name"/>_* _interface_)
        : Stub(_stub_)
        , Stub_information(<xsl:value-of select="code"/>, _stub_)
        , interface_(_interface_)
    {
    }

    ~Stub_method_<xsl:value-of select="name"/>()
    {
    }

  <xsl:if test="out_data!='(null)'">
    Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>* get()
    {
        Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>* ret;
        ret = (Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>*) Stub_information::get(sizeof(Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>) );
        return ret;
    }

    Error post(const Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>* _inf_dat_)
    {
        Error err;
        ::Nerv36::Pksize inf_size = _inf_dat_-&gt;fit_size();
        if( inf_size &lt; sizeof(Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>) ) {
            err = NERV_ERR_UNUSED_DYNAMIC_BUFFER_;
        }
        else {
            err = Stub_information::post( inf_size);
        }
        return err;
    }

    Error write(const Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>* _inf_dat_)
    {
        Error err;
        ::Nerv36::Pksize inf_size = _inf_dat_-&gt;fit_size();
        if( inf_size &lt; sizeof(Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>) ) {
            err = NERV_ERR_UNUSED_DYNAMIC_BUFFER_;
        }
        else {
            err = Stub_information::write(_inf_dat_, inf_size);
        }
        return err;
    }

    Error read( Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>* _inf_dat_)
    {
        Error err;
        Nerv36::Pksize inf_size = sizeof(Nerv36::Data<xsl:value-of select="$out_data_domain_namespace"/>::<xsl:value-of select="out_data"/>);
        err = Stub_information::read(_inf_dat_, &amp;inf_size );
        return err;
    }
  </xsl:if>
  <xsl:if test="out_data='(null)'">
    Error write()
    {
        return Stub_information::write(0, 0);
    }
  </xsl:if>
};
</xsl:template>

</xsl:stylesheet>
