<?xml version="1.0" encoding="UTF-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method="text" encoding="utf-8" indent="yes"/>
<xsl:include href="../../../../../xsl_util.xsl"/>

<xsl:param name = "export_method_domain_path" />
<xsl:param name = "export_method_name" />
<xsl:template match="/"><xsl:text/>
<xsl:variable name="component_name">
  <xsl:call-template name="replace">
    <xsl:with-param name="text" select="nerv_icde/component/name" />
    <xsl:with-param name="replace" select="' '" />
    <xsl:with-param name="by" select="'_'" />
  </xsl:call-template>
</xsl:variable>

  <xsl:for-each select="nerv_icde/methoddomain/row[path=$export_method_domain_path]/method/row[name=$export_method_name]">
    <xsl:variable name="in_data_domain_path">
      <xsl:call-template name="get_data_domain_path">
        <xsl:with-param name="data_domain_id" select="in_data_domain_id" />
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="out_data_domain_path">
      <xsl:call-template name="get_data_domain_path">
        <xsl:with-param name="data_domain_id" select="out_data_domain_id" />
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="underscore_in_path">
      <xsl:call-template name="replace">
        <xsl:with-param name="text" select="$in_data_domain_path" />
        <xsl:with-param name="replace" select="'/'" />
        <xsl:with-param name="by" select="'__'" />
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="underscore_out_path">
      <xsl:call-template name="replace">
        <xsl:with-param name="text" select="$out_data_domain_path" />
        <xsl:with-param name="replace" select="'/'" />
        <xsl:with-param name="by" select="'__'" />
      </xsl:call-template>
    </xsl:variable>
    <xsl:if test="type = 'CALL'">
uint32 seq<xsl:text/>
      <xsl:if test="in_data != '(null)'"><xsl:text>
</xsl:text><xsl:value-of select="$component_name"/>/<xsl:value-of select="in_data"/> dat<xsl:text/>
      </xsl:if>
---<xsl:text/>
uint32 seq<xsl:text/>
uint32 err<xsl:text/>
      <xsl:if test="out_data != '(null)'"><xsl:text>
</xsl:text><xsl:value-of select="$component_name"/>/<xsl:value-of select="out_data"/> dat<xsl:text/>
      </xsl:if>
    </xsl:if>
    <xsl:if test="type = 'CALLBACK'">
uint32 seq<xsl:text/>
      <xsl:if test="out_data != '(null)'"><xsl:text>
</xsl:text><xsl:value-of select="$component_name"/>/<xsl:value-of select="out_data"/> dat<xsl:text/>
      </xsl:if>
---<xsl:text/>
uint32 seq<xsl:text/>
uint32 err<xsl:text/>
      <xsl:if test="in_data != '(null)'"><xsl:text>
</xsl:text><xsl:value-of select="$component_name"/>/<xsl:value-of select="in_data"/> dat<xsl:text/>
      </xsl:if>
    </xsl:if>

  </xsl:for-each>
</xsl:template>
</xsl:stylesheet>
