<?xml version="1.0" encoding="utf-8"?>
<!-- copyright@ 2020, Waregram , All right Reserved. -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:include href="../../xsl_util.xsl"/>
<xsl:output method="text" encoding="utf-8" indent="yes" />
<xsl:template match="/">
<xsl:variable name="component_name">
  <xsl:call-template name="replace">
    <xsl:with-param name="text" select="nerv_icde/component/name" />
    <xsl:with-param name="replace" select="' '" />
    <xsl:with-param name="by" select="'_'" />
  </xsl:call-template>
</xsl:variable>
<xsl:for-each select="/nerv_icde/component/proxy_list/row">
#include "Nerv_Proxy/<xsl:value-of select="class_name"/>/<xsl:value-of select="class_name"/>.h"
</xsl:for-each>
<xsl:for-each select="/nerv_icde/component/stub_list/row">
#include "Nerv_Stub/<xsl:value-of select="class_name"/>/<xsl:value-of select="class_name"/>.h"
</xsl:for-each>

#include &lt;ros/ros.h&gt;

// #include &lt;Waregram/utf8.h&gt;
#include &lt;thread&gt;


using namespace std;
using namespace this_thread;
using namespace chrono;


class <xsl:value-of select="$component_name"/>_nerv_component
{
protected:
    ros::NodeHandle         ros_node;
  <xsl:for-each select="/nerv_icde/component/stub_list/row/object_list/row">
<xsl:text>
    </xsl:text><xsl:value-of select="../../class_name"/><xsl:text> </xsl:text>stub_<xsl:value-of select="object_name"/>;<xsl:text/>
  </xsl:for-each>
  <xsl:for-each select="/nerv_icde/component/proxy_list/row/object_list/row">
<xsl:text>
    </xsl:text><xsl:value-of select="../../class_name"/><xsl:text> </xsl:text>proxy_<xsl:value-of select="object_name"/>;<xsl:text/>
  </xsl:for-each>

    enum {
        INIT_,              // 자원할당 등 초기화
        IDLE_,              //
        READY_,             // 명령
        STANDBY_,
        START_,             // 명령
        RUN_,
        STOP_,              // 명령
        RESET_,             // 명령
        SHUTDOWN_,          // 명령
        FAILURE_,
        EMERGENCY_,         // 명령
        TERMENATED_
    } state;

    size_t cnt;

    void start_stub();
    void start_proxy();

    void stop_stub();
    void stop_proxy();

  <xsl:for-each select="/nerv_icde/component/proxy_list/row/object_list/row">
    <xsl:variable name="method_domain_id" select="../../method_domain_id" />
    <xsl:variable name="interface_name" select="../../interface_name" />
    <xsl:variable name="object_name" select="object_name" />
    <xsl:for-each select="/nerv_icde/methoddomain/row[id=$method_domain_id]">
      <xsl:for-each select="interface/row[name=$interface_name]">
        <xsl:for-each select="membermethod/row">
          <xsl:variable name="method_name" select="method_name" />
          <xsl:for-each select="../../../../method/row[name=$method_name]">
            <xsl:if test="type='INFORMATION' and out_data!='(null)'">
              <xsl:variable name="out_data_domain_namespace">
                <xsl:call-template name="get_data_domain_namespace">
                  <xsl:with-param name="data_domain_id" select="out_data_domain_id" />
                </xsl:call-template>
              </xsl:variable>
    void read_<xsl:value-of select="$object_name"/>_<xsl:value-of select="$method_name"/>();
            </xsl:if>
          </xsl:for-each>
        </xsl:for-each>
      </xsl:for-each>
    </xsl:for-each>
  </xsl:for-each>

    void read_from_proxy();
  <xsl:for-each select="/nerv_icde/component/proxy_list/row/object_list/row">
    <xsl:variable name="method_domain_id" select="../../method_domain_id" />
    <xsl:variable name="interface_name" select="../../interface_name" />
    <xsl:variable name="object_name" select="object_name" />
    <xsl:for-each select="/nerv_icde/methoddomain/row[id=$method_domain_id]">
      <xsl:for-each select="interface/row[name=$interface_name]">
        <xsl:for-each select="membermethod/row">
          <xsl:variable name="method_name" select="method_name" />
          <xsl:for-each select="../../../../method/row[name=$method_name]">
            <xsl:variable name="in_data_domain_namespace">
              <xsl:call-template name="get_data_domain_namespace">
                <xsl:with-param name="data_domain_id" select="in_data_domain_id"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="out_data_domain_namespace">
              <xsl:call-template name="get_data_domain_namespace">
                <xsl:with-param name="data_domain_id" select="out_data_domain_id"/>
              </xsl:call-template>
            </xsl:variable>
            <!-- <xsl:variable name="in_data_domain_namespace_dot" select="substring($in_data_domain_namespace,2)"/>
            <xsl:variable name="out_data_domain_namespace_dot" select="substring($out_data_domain_namespace,2)"/> -->
            <xsl:choose>
              <xsl:when test="type='CALL'">
    void <xsl:value-of select="$object_name"/>_<xsl:value-of select="$method_name"/>_call();
              </xsl:when>
              <xsl:when test="type='SIGNAL'">
    void <xsl:value-of select="$object_name"/>_<xsl:value-of select="$method_name"/>_signal();
              </xsl:when>
              <xsl:when test="type='COMMAND'">
    void <xsl:value-of select="$object_name"/>_<xsl:value-of select="$method_name"/>_command();
              </xsl:when>
            </xsl:choose>
          </xsl:for-each>
        </xsl:for-each>
      </xsl:for-each>
    </xsl:for-each>
  </xsl:for-each>

    void send_from_proxy();
  <xsl:for-each select="/nerv_icde/component/stub_list/row/object_list/row">
    <xsl:variable name="method_domain_id" select="../../method_domain_id" />
    <xsl:variable name="interface_name" select="../../interface_name" />
    <xsl:variable name="object_name" select="object_name" />
    <xsl:for-each select="/nerv_icde/methoddomain/row[id=$method_domain_id]">
      <xsl:for-each select="interface/row[name=$interface_name]">
        <xsl:for-each select="membermethod/row">
          <xsl:variable name="method_name" select="method_name" />
          <xsl:for-each select="../../../../method/row[name=$method_name]">
            <xsl:variable name="in_data_domain_namespace">
              <xsl:call-template name="get_data_domain_namespace">
                <xsl:with-param name="data_domain_id" select="in_data_domain_id"/>
              </xsl:call-template>
            </xsl:variable>
            <xsl:variable name="out_data_domain_namespace">
              <xsl:call-template name="get_data_domain_namespace">
                <xsl:with-param name="data_domain_id" select="out_data_domain_id"/>
              </xsl:call-template>
            </xsl:variable>
            <!-- <xsl:variable name="in_data_domain_namespace_dot" select="substring($in_data_domain_namespace,2)"/>
            <xsl:variable name="out_data_domain_namespace_dot" select="substring($out_data_domain_namespace,2)"/> -->
            <xsl:choose>
              <xsl:when test="type='CALLBACK'">
    void <xsl:value-of select="$object_name"/>_<xsl:value-of select="$method_name"/>_callback();
              </xsl:when>
              <xsl:when test="type='SIGNALBACK'">
    void <xsl:value-of select="$object_name"/>_<xsl:value-of select="$method_name"/>_signalback();
              </xsl:when>
              <xsl:when test="type='EVENT'">
    void <xsl:value-of select="$object_name"/>_<xsl:value-of select="$method_name"/>_event();
              </xsl:when>
              <xsl:when test="type='INFORMATION'">
    void <xsl:value-of select="$object_name"/>_<xsl:value-of select="$method_name"/>_information();
              </xsl:when>

              <xsl:when test="type='BROADCAST'">
    void <xsl:value-of select="$object_name"/>_<xsl:value-of select="$method_name"/>_datagram();
              </xsl:when>
            </xsl:choose>
          </xsl:for-each>
        </xsl:for-each>
      </xsl:for-each>
    </xsl:for-each>
  </xsl:for-each>
  <xsl:for-each select="/nerv_icde/component/stub_list/row/object_list/row">
    <xsl:variable name="method_domain_id" select="../../method_domain_id" />
    <xsl:variable name="interface_name" select="../../interface_name" />
    <xsl:variable name="object_name" select="object_name" />
    <xsl:for-each select="/nerv_icde/methoddomain/row[id=$method_domain_id]">
      <xsl:for-each select="interface/row[name=$interface_name]">
        <xsl:for-each select="membermethod/row">
          <xsl:variable name="method_name" select="method_name" />
          <xsl:for-each select="../../../../method/row[name=$method_name]">
            <xsl:if test="type='COMMAND' and in_data!='(null)'">
              <xsl:variable name="data_domain_namespace">
                <xsl:call-template name="get_data_domain_namespace">
                  <xsl:with-param name="data_domain_id" select="in_data_domain_id" />
                </xsl:call-template>
              </xsl:variable>
    void read_<xsl:value-of select="$object_name"/>_<xsl:value-of select="$method_name"/>();
            </xsl:if>
          </xsl:for-each>
        </xsl:for-each>
      </xsl:for-each>
    </xsl:for-each>
  </xsl:for-each>
    void read_from_stub();
    void send_from_stub();

protected:
    void initialize();
    void idle();
    void standby();
    void run();
    void finalize();

public:
    <xsl:value-of select="$component_name"/>_nerv_component();
    ~<xsl:value-of select="$component_name"/>_nerv_component();

    void ready();
    void start();
    void stop();
    void reset();
    void shutdown();
    void failure();
    void emergency();

public:
    void excute_state_machine();
};


</xsl:template>
</xsl:stylesheet>
