#pragma once

#include "nerv_define.h"
#include "nerv_typedef.hh"
#include <Nerv36/nerv_error.hh>

namespace Nerv36 {

struct Proxy_ {
    virtual void on_connect() = 0;
    virtual void on_disconnect() = 0;
};

class NERV_SDK_DLL Proxy {
    friend class Nerv_processor;
    friend class _Proxy;

public:
    Proxy();
    Proxy(const Proxy& _proxy_object_);
    virtual ~Proxy();
    Error start(const char* _url_);
    Error stop();
    bool  is_connected();
    bool  is_started();
    Error get_address(Address* _proxy_addr_, Address* _stub_addr_);

protected:
    virtual void on_connect();
    virtual void on_disconnect();

protected:
    _Proxy* _pp;
};

} // namespace Nerv36
