#pragma once

#include "Proxy.hh"
#include "nerv_error.hh"

namespace Nerv36 {
class NERV_SDK_DLL Proxy_callback : virtual public Proxy {
    friend class _Proxy_callback;

public:
    Proxy_callback(Msg_code _code, Pksize _max_return_size);
    Proxy_callback(Msg_code     _code,
                   Pksize       _max_return_size,
                   const Proxy& _proxy_);

    virtual ~Proxy_callback(void);

private:
    virtual Error on_callback(const void* _in_buf_,
                              Pksize      _in_buf_size,
                              void*       _out_buf_,
                              Pksize*     _out_buf_size_,
                              double      _elapsed,
                              double      _limit);
    virtual void  on_callback_cancel( Error _error);

private:
    _Proxy_callback* _mp;
};
} // namespace Nerv36
