#pragma once

#include "Proxy.hh"
#include <Nerv36/History.hh>

namespace Nerv36 {

class NERV_SDK_DLL Proxy_command : virtual public Proxy {
    friend class _Proxy_command;
    friend class _Proxy;

public:
    Proxy_command(Msg_code _code);
    Proxy_command(Msg_code _code, const Proxy& _proxy_object_);
    virtual ~Proxy_command();

    bool is_linked();

    Error delegate_link(Msg_num* _msg_num_, double _limit);

    const Promise_ async_link(double _limit = 1.0);
    Error       await_link_return(Promise_ _promise_, double* _time_);
    void           unlink();
    void           set_sync_model(bool       _reliability,
                                  Sync_model _sync_model,
                                  double     _interval);
    void*          get(Pksize _size);
    void           cancel();
    Error       post(Pksize _size);
    Error       write(const void* _data_, Pksize _size);
    Letter_case_   see_history(size_t _size);
    void           set_history_size(size_t _history_size);
    Error       read(void* _data_, Pksize* _size_);

protected:
    virtual void on_unlink(Error _err);
    virtual void on_link(Msg_num _msg_num, Error _err, double _time_);

protected:
    _Proxy_command* _mp;
};

} // namespace Nerv36
