#pragma once

#include "Proxy.hh"

namespace Nerv36 {

class NERV_SDK_DLL Proxy_signal : virtual public Proxy {
    friend class _Proxy_signal;

public:
    Proxy_signal(Msg_code _code);
    Proxy_signal(Msg_code _code, const Proxy& _proxy_object_);
    virtual ~Proxy_signal(void);

    Error delegate_signal(Msg_num*    _msg_num_,
                             const void* _signal_data_,
                             Pksize      _signal_size,
                             double      _limit);

    const Promise_ async_signal(const void* _signal_data_,
                                Pksize      _call_size,
                                double      _limit = 1.0);
    Error       await_return(Promise_ _ret_promise, double* _time_ = 0);
    Error       signal(const void*  _signal_data_,
                          Pksize const _signal_size,
                          double       _limit = 1.0,
                          double*      _time_ = 0);
    void           cancel(Error _error);

private:
    virtual void
        on_return(Msg_num _msg_num, Error _err, double _elapsed);

private:
    _Proxy_signal* _mp;
};

} // namespace Nerv36
