#pragma once

#include "Stub.hh"
#include "nerv_error.hh"

namespace Nerv36 {
class NERV_SDK_DLL Stub_call : virtual public Stub {
    friend class _Stub_call;

public:
    Stub_call(Msg_code _code, Pksize _max_return_size);
    Stub_call(Msg_code _code, Pksize _max_return_size, const Stub& _stub_);

    virtual ~Stub_call(void);

private:
    virtual Error on_call(Address        _proxy_addr,
                             const void* _in_buf_,
                             Pksize      _in_buf_size,
                             void*       _out_buf_,
                             Pksize*     _out_buf_size_,
                             double      _elapsed,
                             double      _limit);
    virtual void     on_call_cancel(Address _proxy_addr, Error _error);

private:
    _Stub_call* _mp;
};
} // namespace Nerv36
