#pragma once

#include "nerv_define.h"
#include "nerv_typedef.hh"


namespace Nerv36 {

typedef uint8_t Transaction;

constexpr Transaction NERV_TRANSACTION_OBJECT_ = 0U;
constexpr Transaction NERV_TRANSACTION_CALL_ = 1U;
constexpr Transaction NERV_TRANSACTION_SIGNAL_ = 2U;
constexpr Transaction NERV_TRANSACTION_EVENT_ = 3U;
constexpr Transaction NERV_TRANSACTION_COMMAND_ = 4U;
constexpr Transaction NERV_TRANSACTION_INFORMATION_ = 5U;
constexpr Transaction NERV_TRANSACTION_DATAGRAM_ = 6U;
constexpr Transaction NERV_TRANSACTION_CALLBACK_ = 7U;
constexpr Transaction NERV_TRANSACTION_SIGNALBACK_ = 8U;

struct Msg_addr {
    Port        port;
    Msg_code    code;
    Transaction transaction;
};

inline bool operator<(Msg_addr _left, Msg_addr _right)
{
    return (_left.port < _right.port) ||
           (_left.port == _right.port && _left.code < _right.code) ||
           (_left.port == _right.port && _left.code == _right.code &&
            _left.transaction < _right.transaction);
}

NERV_SDK_DLL void msg_processing_by_serial_group(Msg_addr _a, Msg_addr _b);
NERV_SDK_DLL void msg_processing_by_serial_alone(Msg_addr _a);
NERV_SDK_DLL void msg_processing_by_parallel(Msg_addr _a);

} // namespace Nerv36
