#pragma once

#include "nerv_define.h"
#include "nerv_typedef.hh"

namespace Nerv36 {

class NERV_SDK_DLL Named_addresses {
    friend class Nerv_processor;
    void* p;

public:
    Named_addresses();
    ~Named_addresses();
    size_t      size();
    const char* name(size_t _index);
    Address        addr(size_t _index);
    int         ttl(size_t _index);
    void        capture();
};

// NERV_SDK_DLL size_t get_address(const char* _name_, Address* _stub_addr_);
// NERV_SDK_DLL size_t get_addresses(const char* _name_,
//                                   Address*       _stub_addr_,
//                                   size_t      _size);

NERV_SDK_DLL IP          inet_addr(const char* _ip_);
NERV_SDK_DLL const char* inet_ntoa(IP _ip);

NERV_SDK_DLL Clock get_cpu_clock();
NERV_SDK_DLL Clock get_cpu_hz();

NERV_SDK_DLL void initialize();
NERV_SDK_DLL void initialize(size_t _thread_count,
                             size_t _call_buffer_count,
                             size_t _udp_buffer_count);
NERV_SDK_DLL void initialize(size_t _thread_count,
                             size_t _call_buffer_count,
                             size_t _udp_buffer_count,
                             Port   _name_port);
NERV_SDK_DLL void finalize();

NERV_SDK_DLL bool dispatch_message();
NERV_SDK_DLL bool dispatch_message(double in_timeout);


} // namespace Nerv36
